%Buy Example 3.16 Becker-Nanz TR->ESORICS'07

%holds(P,H) :- Property P holds after the sequence H of events
%latest events first

holds(true,_H).
holds(and(A,B),H) :- holds(A,H), holds(B,H).
holds(not(A),H) :- \+ holds(A,H).
holds(P,[E|Es]) :- elem(P), event(E), initiates(E,P), happens(E,Es).
holds(P,[E|Es]) :- elem(P), event(E), \+ terminates(E,P), happens(E,Es), holds(P,Es).


%happens(E,Es) :- E is an event that happens after the sequence Es of events

happens(buy,_Es).
happens(play1,Es) :- 
	holds(bought,Es), 
	holds(not(played1),Es).
happens(play2,Es) :- 
	holds(played1,Es), 
	holds(not(played2),Es).


%elem(P) :- P is an elementary property

elem(bought).
elem(played1).
elem(played2).


%event(E) :- E is an event.

event(buy).
event(play1).
event(play2).


% initiates(Event,Property) :- Property holds after Event

initiates(buy,bought).
initiates(play1,played1).
initiates(play2,played2).


% terminates(Event,Property) :- Property ceases to hold after Event

terminates(buy,played1).
terminates(play1,played2).
terminates(play2,bought).


holds_played2(H) :- holds(played2,H).


/* Queries

| ?- holds(played2,Es).
Es = [play2,play1,buy|_A] ? 
yes

| ?- holds(and(played1,not(bought)),[play2,play1,buy]).
yes
*/