%Buy Example 3.16 Becker-Nanz TR->ESORICS'07

%holds(P,H) :- Property P holds after the sequence H of events
%latest events first

holds(true,_H).
holds(and(A,B),H) :- holds(A,H), holds(B,H).
holds(not(A),H) :- \+ holds(A,H).
holds(P,[E|Es]) :- elem(P), event(E), initiates(E,P), happens(E,Es).
holds(P,[E|Es]) :- elem(P), event(E), \+ terminates(E,P), happens(E,Es), holds(P,Es).


%happens(E,Es) :- E is an event that happens after the sequence Es of events

happens(buy(X,M),_Es).
happens(play1(X,M),Es) :- 
	holds(bought(X,M),Es), 
	holds(not(played1(X,M)),Es).
happens(play2(X,M),Es) :- 
	holds(played1(X,M),Es), 
	holds(not(played2(X,M)),Es).


%elem(P) :- P is an elementary property

elem(bought(X,M)).
elem(played1(X,M)).
elem(played2(X,M)).


%event(E) :- E is an event.

event(buy(X,M)).
event(play1(X,M)).
event(play2(X,M)).


% initiates(Event,Property) :- Property holds after Event

initiates(buy(X,M),bought(X,M)).
initiates(play1(X,M),played1(X,M)).
initiates(play2(X,M),played2(X,M)).


% terminates(Event,Property) :- Property ceases to hold after Event

terminates(buy(X,M),played1(X,M)).
terminates(play1(X,M),played2(X,M)).
terminates(play2(X,M),bought(X,M)).


holds_played2(X,M,H) :- holds(played2(X,M),H).


/* Queries

| ?- holds(played2,Es).
Es = [play2,play1,buy|_A] ? 
yes

| ?- holds(and(played1,not(bought)),[play2,play1,buy]).
yes
*/