/* Approximate matching: Initial Program */

a_match(S,T,K) :-
        app(X,Right,T),
        app(Left,P,X),
        dist(S,P,D),
        leq(D,K).

app([],L,L).
app([A|L1],L2,[A|L3]):-
        app(L1,L2,L3).

dist([],[],0).
dist([X|Xs],[X|Ys],D) :- dist(Xs,Ys,D).
%dist([X|Xs],[Y|Ys],s(D)) :- \+ X=Y, dist(Xs,Ys,D).
dist([a|Xs],[b|Ys],s(D)) :- dist(Xs,Ys,D).
dist([b|Xs],[a|Ys],s(D)) :- dist(Xs,Ys,D).

leq(0,Y).
leq(s(X),s(Y)) :- leq(X,Y).


/* Specialization wrt:
new1(A) :- a_match([a,a,b],A,s(s(0))).

Final program :

13. new1(A) :- new2(A).
28. new2([a|A]) :- new3(A).
31. new2([b|A]) :- new4(A).
32. new2([A|B]) :- \+A=b, \+A=a, new2(B).
53. new3([a|A]) :- new5(A).
57. new3([b|A]) :- new6(A).
58. new3([A|B]) :- \+A=b, \+A=a, new2(B).
232. new4([a|A]) :- new11(A).
236. new4([b|A]) :- new12(A).
237. new4([A|B]) :- \+A=b, \+A=a, new2(B).
85. new5([b|A]) :- new7(A).
90. new5([a|A]) :- new8(A).
91. new5([A|B]) :- \+A=a, \+A=b, new2(B).
162. new6([b|A]) :- new9(A).
167. new6([a|A]) :- new10(A).
168. new6([A|B]) :- \+A=a, \+A=b, new2(B).
101. new7(A).
123. new8(A).
178. new9(A).
199. new10(A).
264. new11([b|A]) :- new13(A).
269. new11([a|A]) :- new14(A).
270. new11([A|B]) :- \+A=a, \+A=b, new2(B).
340. new12([b|A]) :- new15(A).
341. new12([a|A]) :- new11(A).
342. new12([A|B]) :- \+A=a, \+A=b, new2(B).
280. new13(A).
302. new14(A).
352. new15(A).
*/


/* Approximate Matching */

% %% INITIAL PROGRAM
% file_input('Progs/approx_match.pl').
%
% %%% INITIAL DEFINITION
% %init_def(new1,2,[(new1(A,B), [a_match([a,a,b],A,B)])]).
% init_def(new1,1,[(new1(A), [a_match([a,a,b],A,s(s(0)))])]).
% %init_def(new1,1,[(new1(A), [a_match([a,a,a,a,b],A,s(s(0)))])]).
%
% %%% SUBSIDIARY STRATEGIES
% %strat(after_first_step_unfold_leftmost_weak_consumer). %NON-TERMINATING
% strat(after_first_step_unfold_leftmost_consumer).
% strat(apply_subsumption(after_unfolding)).
% strat(delete_clauses_with_failing_body).
% strat(apply_case_split(binary)).
% %strat(apply_case_split(global_analysis)).
%
% %%% MODES
% mode(a_match,3,[+,+,+]).
% mode(app,3,[-,-,+]).
% mode(dist,3,[+,+,-]).
% mode(leq,2,[+,+]).

