%parser for context-free languages

string_parse(G,S,W) :- string(W), parse(G,S,W).

parse(G,[],[]).
parse(G,[T|S],[T|W]) :- terminal(T), parse(G,S,W).
parse(G,[N|S],W) :- 
        nonterminal(N),
        member((N,R), G),
        app(R,S,U),
        parse(G,U,W).

app([],Y,Y).
app([H|X],Y,[H|Z]) :- app(X,Y,Z).

terminal(0).
terminal(1).

nonterminal(s).
nonterminal(u).
nonterminal(v).
nonterminal(w).

%production(P,(Ts,Ns,Ps)) :- member(P,Ps).

member(X,[X|S]).
member(X,[Y|S]) :- member(X,S).

string([]).
string([0|S]) :- string(S).
string([1|S]) :- string(S).