bp([], _, []).

bp([Block|Blocks], [(Bin,Size)|Bins], [Bin|Rep]) :-
    Block =< Size,
    NewSize is Size - Block,
    bp(Blocks, [(Bin,NewSize)|Bins], Rep).

bp([Block|Blocks], [(Bin,Size)|Bins], [Bin2|Rep]) :-
%   Block > Size,
   bp2(Block, Bins, NewBins, Bin2),
   bp(Blocks, [(Bin,Size)| NewBins], Rep).

bp2(Block, [(Bin,Size)|Bins], [(Bin,NewSize)|Bins], Bin) :-
    Block =< Size,
    NewSize is Size - Block.

bp2(Block, [(Bin,Size)|Bins], [(Bin,Size)|NewBins], Bin2) :-
%    Block > Size,
    bp2(Block, Bins, NewBins, Bin2).

ord([]).
ord([F]).
ord([E,F|L]) :- F =< E, ord([F|L]).

newbp(B1,B2,B3,S,Rep ) :- 
    ord([B1,B2,B3]),
    bp([B1,B2,B3], [(1,S),(2,S)], Rep).

/*
Specialized goal: 3 blocks of decreasing size B1, B2 and B3. Two bins of equal
size.

Expected specialized program 

newbp(B1,B2,B3,S,[1,2,2]) :- B1 =< S, B2 + B3 =< S.

*/
