:- use_module(library(clpr)).

p(Xs) :- list(Xs), \+aux(Xs).

list([]).
list([_|B]) :- list(B).

aux(Xs) :- {X<Y, I>=1, J>=1}, member(X,I,Xs), even(I), member(Y,J,Xs), \+even(J).

member(X,I,[Y|_]) :- {I=:=1, X=:=Y}.
member(X,I,[_|Ys]) :- {I>=2, I1=:=I-1}, member(X,I1,Ys).

even(X) :- {X=:=0}.
even(X) :- {X>=1, X1=:=X-1}, \+even(X1).

p1([]).
p1([_]).
p1([A,B|C]) :- new3(A,B,C).
new3(A,B,[]) :- {B>=A}.
new3(A,B,[C|D]) :- {A<C, B>=A}, new4(C,B,D).
new3(A,B,[C|D]) :- {A>=C, B>=C}, new4(A,B,D).
new4(A,B,[]) :- {B>=A}.
new4(A,B,[C|D]) :- {B<C, C>=A}, new3(A,B,D).
new4(A,B,[C|D]) :- {B>=C, B>=A}, new3(A,C,D).



%-------------- Tests ---------------

repeat(N,_) :- N=0.
repeat(N,G) :- N>0, !, (G;true), N1 is N-1, repeat(N1,G).

test50 :-
	Xs=[0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,
	    0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,
	    0,1,0,1,0,1,0,1,0,1],
        statistics(runtime, [T1|_]),
	p(Xs),
        statistics(runtime, [T2|_]),
        repeat(100,(p1(Xs),false)),
        statistics(runtime, [T3|_]),
        Tin is (T2-T1),
        write('runtime (initial) = '), write(Tin), nl,
        Tfin is (T3-T2)/100,
        write('runtime (final) = '), write(Tfin), nl,
        Speedup is Tin/Tfin,
        write('speedup = '), write(Speedup).

test100 :-
	Xs=[0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,
	    0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,
	    0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,
	    0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,
	    0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1],
        statistics(runtime, [T1|_]),
	p(Xs),
        statistics(runtime, [T2|_]),
        repeat(100,(p1(Xs),false)),
        statistics(runtime, [T3|_]),
        Tin is (T2-T1),
        write('runtime (initial) = '), write(Tin), nl,
        Tfin is (T3-T2)/100,
        write('runtime (final) = '), write(Tfin), nl,
        Speedup is Tin/Tfin,
        write('speedup = '), write(Speedup).

/*

| ?- test50.
runtime (initial) = 1630
runtime (final) = 1.6
speedup = 1018.75
yes
| ?- test100.
runtime (initial) = 11550
runtime (final) = 3.1
speedup = 3725.806451612903
yes

*/