%:-use_module(library(clpr)).

q(A,B) :- board(A,B), safe(A).
board(A,B) :- len(A,B), \+aux1(A,B).
aux1(A,B) :- m(C,A), \+ in_range(C,1,B).
safe(A) :- \+aux2(A).
aux2(A) :- {C<E, (B=:=D; (B>=D,B-D=:=E-C); (B<D, D-B=:=E-C))}, occurs(B,C,A), occurs(D,E,A).
len([],N) :- {N=:=0}.
len([_|B],C) :- {C>0, D=:=C-1}, len(B,D).
m(A,[B|_]) :- {A=:=B}.
m(A,[_|C]) :- m(A,C).
occurs(A,B,[C|_]) :- {A=:=C, B=:=1}.
occurs(A,B,[_|D]) :- {B>1, E=:=B-1}, occurs(A,E,D).

queens(A,B) :- new2(A,B,0).
new2([],A,A) :- {A>=0}.
new2([A|B],C,D) :- {D1=<C, D1=:=D+1}, new2(B,C,D1), in_range(A,1,C), new4(A,B,0).
new4(_,[],_).
new4(A,[B|C],D) :- {A=\=B, D1=:=D+1}, \+ attack(A,B,D), new4(A,C,D1).

in_range(A,N,N) :- {N>=A}.
in_range(A,N,M) :- {M>=1, M1=:=M-1}, in_range(A,N,M1).

%not_attack(A,B,D) :- {A>=B, A-B=\=D+1}.
%not_attack(A,B,D) :- {A<B, B-A=\=D+1}.
attack(A,B,D) :- {A>=B, A-B=:=D+1}.
attack(A,B,D) :- {A<B, B-A=:=D+1}.

