queens(L,N) :-
	board(L,N),
	safe(L).

board(L,N) :-
	length(L,N),
	\+ aux1(L,N).

aux1(L,N) :-
	m(X,L),
	\+(1=<X, X=<N).

safe(L) :- \+aux2(L).

aux2(L) :-
	occurs(A,M,L),
	occurs(B,N,L),
	M<N,
	\+(\+(A=B),\+(abs(A-B)=(N-M))).

length([],0).
length([X|Xs],N) :-
	M=N-1,
	length(Xs,M).

m(X,[Y|Xs]) :- X=Y.
m(X,[Y|Xs]) :- m(X,Xs).

occurs(A,N,[X|Xs]) :- A=X, N=1.
occurs(A,N,[X|Xs]) :-
	M=N-1,
	occurs(A,M,Xs).

