%complement of a context-free language

not_parse(W) :- 
	word(W), 
	\+ parse([s],W).
	
word([]).
word([X|Xs]) :- terminal(X), word(Xs).

parse([],[]).
parse([T|S],[T|W]) :- terminal(T), parse(S,W).
parse([N|S],W) :- 
      	nonterminal(N),
      	production(N,R), 
      	app(R,S,U), 
      	parse(U,W).
      	
app([],Y,Y).
app([H|X],Y,[H|Z]) :- app(X,Y,Z).

terminal(a).
terminal(b).

nonterminal(s).
nonterminal(x).

production(s,[a,x,b]).
production(x,[]).
production(x,[a,x]).
production(x,[a,b,x]).

