queens(L,N) :-
	N>=0,
	board(L,N),
	safe(L).

%board([],0).
%board([X|Xs],N) :-
%	N>=1,
%	N1=N-1,
%	in_range(X,1,N),
%	board(Xs,N1).

board(L,N) :-
	length(L,N),
	\+ aux1(L,N).

aux1(L,N) :-
	m(X,L),
	\+ in_range(X,1,N).

safe(L) :-
	list(L),
	\+aux2(L).

aux2(L) :-
	M>=1,
	M+1=<N,
	\+(\+(A=B),\+((A-B)=(N-M)),\+((B-A)=(N-M))),
	occurs(A,M,L),
	occurs(B,N,L).

length([],0).
length([X|Xs],N) :-
	N>=1,
	N1=N-1,
	length(Xs,N1).

m(X,[Y|Xs]) :- X=Y.
m(X,[Y|Xs]) :- m(X,Xs).

in_range(A,M,N) :- A=M, M=N.
in_range(A,M,N) :-
	N>=1,
	N1=N-1,
	in_range(A,M,N1).

list([]).
list([A|B]) :- list(B).

occurs(A,N,[X|Xs]) :- N=1, A=X.
occurs(A,N,[X|Xs]) :-
	N>=2,
	N1=N-1,
	occurs(A,N1,Xs).

