queens(N,L) :-
	nat(N),
	nat_list(L),
	length(L,N),
	\+ aux1(L,N),
	\+aux2(L).

nat(0).
nat(N) :-
	N=K+1,
	K>=0,
	nat(K).

nat_list([]).
nat_list([A|B]) :-
	nat(A),
	nat_list(B).

length([],0).
length([X|Xs],N) :-
	N=K+1,
	K>=0,
	length(Xs,K).

aux1(L,N) :-
	m(X,L),
	\+ in_range(X,1,N).

aux2(L) :-
	M>=1,
	M+1=<N,
	\+(\+(X=Y),\+((X-Y)=(N-M)),\+((Y-X)=(N-M))),
	occurs(X,M,L),
	occurs(Y,N,L).

m(X,[Y|Ys]) :- X=Y.
m(X,[Y|Ys]) :- m(X,Ys).

in_range(X,M,N) :- X=M, M=N.
in_range(X,M,N) :-
	N=K+1,
	K>=0,
	in_range(X,M,K).

occurs(X,N,[Y|Ys]) :- N=1, X=Y.
occurs(X,N,[Y|Ys]) :-
	N=K+1,
	K>=1,
	occurs(X,K,Ys).