%parser for context-free languages

mode(sp_parse,[+]).
mode(parse,[+,+,+]).
mode(terminal,[-]).
mode(nonterminal,[-]).
mode(member,[-,-]).
mode(app,[-,-,-]).
mode(string,[+]).

parse(G,[],[]).
parse(G,[T|S],[T|W]) :- terminal(T), parse(G,S,W).
parse(G,[N|S],W) :- 
        nonterminal(N),
        member((N->R), G),
        app(R,S,U),
        parse(G,U,W).

app([],Y,Y).
app([H|X],Y,[H|Z]) :- app(X,Y,Z).

terminal(0).
terminal(1).

nonterminal(s).
nonterminal(u).
nonterminal(v).
nonterminal(w).

member(X,[X|S]).
member(X,[Y|S]) :- member(X,S).

sp_parse(W) :- 
%	 string(W), 
	 parse([(s->[0,u]), (s->[0,v]), (s->[0,w]), (u->[0]),
		(u->[0,u]), (u->[0,v]), (v->[0]), (v->[0,v]),
 		(v->[0,u]), (w->[1]), (w->[0,w])], [s], W).


string([]).
string([0|S]) :- string(S).
string([1|S]) :- string(S).
