% EVENSUM

sum([],0).					% w1
sum([H|T],S) :- sum(T,H+S).			% w2

evenl([],[]).					% w3
evenl([H|T],[H|R]) :- even(H), evenl(T,R).	% w4
evenl([H|T],R) :- odd(H), evenl(T,R).		% w5

even(0).					% w6
even(X) :- odd(X-1).				% w7

odd(X) :- even(X-1).				% w8

evensum(L,S) :- evenl(L,L1), sum(L1,S).		% w9


% ----

/*
Initial program:

1. sum([],0).
2. sum([A|B],C) :- sum(B,A+C).
3. evenl([],[]).
4. evenl([A|B],[A|C]) :- even(A), evenl(B,C).
5. evenl([A|B],C) :- odd(A), evenl(B,C).
6. even(0).
7. even(A) :- odd(A-1).
8. odd(A) :- even(A-1).
9. evensum(A,B) :- evenl(A,C), sum(C,B).

| ?- u.
        1      1 Call: u ? l
clause number  [no]: 9
Number  [1]: 

% by unfolding clause 9 w.r.t. atom 1 we get:
10. evensum([],A) :- sum([],A).
11. evensum([A|B],C) :- even(A), evenl(B,D), sum([A|D],C).
12. evensum([A|B],C) :- odd(A), evenl(B,D), sum(D,C).
yes
% trace
| ?- u.
        1      1 Call: u ? l
clause number  [no]: 11
Number  [1]: 3

by unfolding clause 11 w.r.t. atom 3 we get:
13. evensum([A|B],C) :- even(A), evenl(B,D), sum(D,A+C).
yes
% trace
| ?- p1.
        1      1 Call: p1 ? l

Initial program:

1. sum([],0).
2. sum([A|B],C) :- sum(B,A+C).
3. evenl([],[]).
4. evenl([A|B],[A|C]) :- even(A), evenl(B,C).
5. evenl([A|B],C) :- odd(A), evenl(B,C).
6. even(0).
7. even(A) :- odd(A-1).
8. odd(A) :- even(A-1).
9. evensum(A,B) :- evenl(A,C), sum(C,B).
yes
% trace
| ?- p.
        1      1 Call: p ? l
1. sum([],0).
2. sum([A|B],C) :- sum(B,A+C).
3. evenl([],[]).
4. evenl([A|B],[A|C]) :- even(A), evenl(B,C).
5. evenl([A|B],C) :- odd(A), evenl(B,C).
6. even(0).
7. even(A) :- odd(A-1).
8. odd(A) :- even(A-1).
10. evensum([],A) :- sum([],A).
13. evensum([A|B],C) :- even(A), evenl(B,D), sum(D,A+C).
12. evensum([A|B],C) :- odd(A), evenl(B,D), sum(D,C).
yes
% trace
| ?- notrace.
% The debugger is switched off
yes
| ?- p1.

Initial program:

1. sum([],0).
2. sum([A|B],C) :- sum(B,A+C).
3. evenl([],[]).
4. evenl([A|B],[A|C]) :- even(A), evenl(B,C).
5. evenl([A|B],C) :- odd(A), evenl(B,C).
6. even(0).
7. even(A) :- odd(A-1).
8. odd(A) :- even(A-1).
9. evensum(A,B) :- evenl(A,C), sum(C,B).
yes
| ?- pp.
10. evensum([],A) :- sum([],A).
13. evensum([A|B],C) :- even(A), evenl(B,D), sum(D,A+C).
12. evensum([A|B],C) :- odd(A), evenl(B,D), sum(D,C).
yes
| ?- f([13],[9]).

by folding clause [13] using [9] we get:
14. evensum([A|B],C) :- even(A), evensum(B,A+C).
yes
| ?- f([12],[9]).

by folding clause [12] using [9] we get:
15. evensum([A|B],C) :- odd(A), evensum(B,C).
yes
| ?- p.
1. sum([],0).
2. sum([A|B],C) :- sum(B,A+C).
3. evenl([],[]).
4. evenl([A|B],[A|C]) :- even(A), evenl(B,C).
5. evenl([A|B],C) :- odd(A), evenl(B,C).
6. even(0).
7. even(A) :- odd(A-1).
8. odd(A) :- even(A-1).
10. evensum([],A) :- sum([],A).
14. evensum([A|B],C) :- even(A), evensum(B,A+C).
15. evensum([A|B],C) :- odd(A), evensum(B,C).
yes
| ?- u.
clause number  [no]: 10
Number  [1]: 

by unfolding clause 10 w.r.t. atom 1 we get:
16. evensum([],0).
yes
| ?- p.
1. sum([],0).
2. sum([A|B],C) :- sum(B,A+C).
3. evenl([],[]).
4. evenl([A|B],[A|C]) :- even(A), evenl(B,C).
5. evenl([A|B],C) :- odd(A), evenl(B,C).
6. even(0).
7. even(A) :- odd(A-1).
8. odd(A) :- even(A-1).
16. evensum([],0).
14. evensum([A|B],C) :- even(A), evensum(B,A+C).
15. evensum([A|B],C) :- odd(A), evensum(B,C).
yes
| ?- current_constr.
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(16,w(16)),(14,w(14)),(15,w(15))]
CCS            :[w(10)=:=w(9)+w(3),w(11)=:=w(9)+w(4),w(12)=:=w(9)+w(5),w(13)=:=w(11)+w(2),w(14)=<w(13)-w(9),w(15)=<w(12)-w(9),w(16)=:=w(10)+w(1)]
yes
| ?- solve_constr.
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(16,w(16)),(14,w(14)),(15,w(15))]
CCS            :[w(10)=:=w(9)+w(3),w(11)=:=w(9)+w(4),w(12)=:=w(9)+w(5),w(13)=:=w(11)+w(2),w(14)=<w(13)-w(9),w(15)=<w(12)-w(9),w(16)=:=w(10)+w(1)]
The actual constraints system is the following:
Clause weights :[(1,A),(2,B),(3,C),(4,D),(5,E),(6,F),(7,G),(8,H),(16,I),(14,J),(15,K)]
Constraint     :{L=:=M+C,N=:=M+D,O=:=M+E,P=:=N+B,J=<P-M,K=<O-M,I=:=L+A,A>=1,B>=1,C>=1,D>=1,E>=1,F>=1,G>=1,H>=1,I>=1,J>=1,K>=1,A>=0,B>=0,C>=0,D>=0,E>=0,I>=0,J>=0,K>=0,L>=0,M>=0,N>=0,O>=0,P>=0}
Clause number 1 weight 1
Clause number 2 weight 1
Clause number 3 weight 1
Clause number 4 weight 1
Clause number 5 weight 1
Clause number 6 weight 1
Clause number 7 weight 1
Clause number 8 weight 1
Clause number 16 weight 2
Clause number 14 weight 1
Clause number 15 weight 1

*/

