% INSERTION SORT TRANSFORMATION W WEIGHTS CORRECTNESS

% PROGRAM

sort(X,Y) :- perm(X,Y), ordered(Y).			% w(1)

perm([],[]).						% w(2)
perm([A|X],[Y]) :- perm(X,Z), insert(A,Z,Y).		% w(3)

insert(A,X,[A|X]) :- list(X).				% w(4)
insert(A,[B|X],[B|Y]) :- insert(A,X,Y).			% w(5)

op_insert(A,[],[A]).					% w(6)
op_insert(A,[B|X],[A,B|Y]) :- A=<B.			% w(7)
op_insert(A,[B|X],[B|Y]) :- A>B, op_insert(A,X,Y).	% w(8)

ordered([]).						% w(9)
ordered([_]).						% w(10)
ordered([X,Y|L]) :- X=<Y, ordered([Y|L]).		% w(11)

list([]).						% w(12)
list([_|T]) :- list(T).					% w(13)

% LAWS

% Law 1
new1(A,Y,Z) :- insert(A,Y,Z),ordered(Z).		% w(14)
new2(A,Y,Z) :- ordered(Y),op_insert(A,Y,Z).		% w(15)
% liberal
% law(([insert(A,Y,Z),ordered(Z)],[ordered(Y),op_insert(A,Y,Z)]),(w(15)-w(14)),[]).
% strict

% Law 2
new3(B,C) :- list(C),ordered([B|C]).			% w(16)
new4(B,C) :- ordered([B|C]).				% w(17)
% liberal
% law(([],[]),(w(17)-w(16)),[w(13)>=0,(w(16)+w(12)-w(17))>=0]).
% strict
law(([],[]),(w(17)-w(16)),[w(13)>=0,(w(16)+w(12)-w(17))>=0,w(11)>=1,(w(11)+w(13))>=1,(w(10)+w(16)+w(12))>=1,(w(17)+w(10))>=1]).
/*
P1: Progs/insertion_sort.pl
P2: by unfolding cl 16 in P1 wrt atom 1 using P1
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13)),(14,w(14)),(15,w(15)),(20,w(20)),(21,w(21)),(17,w(17)),(18,w(18)),(19,w(19))]
CCS            :[w(20)=:=w(16)+w(12),w(21)=:=w(16)+w(13)]

P3: by unfolding cl 17 in P2 wrt atom 1 using P1
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13)),(14,w(14)),(15,w(15)),(20,w(20)),(21,w(21)),(22,w(22)),(23,w(23)),(18,w(18)),(19,w(19))]
CCS            :[w(20)=:=w(16)+w(12),w(21)=:=w(16)+w(13),w(22)=:=w(17)+w(10),w(23)=:=w(17)+w(11)]

P4: by unfolding cl 21 in P3 wrt atom 2 using P1
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13)),(14,w(14)),(15,w(15)),(20,w(20)),(24,w(24)),(22,w(22)),(23,w(23)),(18,w(18)),(19,w(19))]
CCS            :[w(20)=:=w(16)+w(12),w(21)=:=w(16)+w(13),w(22)=:=w(17)+w(10),w(23)=:=w(17)+w(11),w(24)=:=w(21)+w(11)]

P5: by unfolding cl 20 in P4 wrt atom 1 using P1
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13)),(14,w(14)),(15,w(15)),(25,w(25)),(24,w(24)),(22,w(22)),(23,w(23)),(18,w(18)),(19,w(19))]
CCS            :[w(20)=:=w(16)+w(12),w(21)=:=w(16)+w(13),w(22)=:=w(17)+w(10),w(23)=:=w(17)+w(11),w(24)=:=w(21)+w(11),w(25)=:=w(20)+w(10)]

P6: by moving atom from position 1 to position 2 in cl 24 in P5
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13)),(14,w(14)),(15,w(15)),(25,w(25)),(26,w(24)),(22,w(22)),(23,w(23)),(18,w(18)),(19,w(19))]
CCS            :[w(20)=:=w(16)+w(12),w(21)=:=w(16)+w(13),w(22)=:=w(17)+w(10),w(23)=:=w(17)+w(11),w(24)=:=w(21)+w(11),w(25)=:=w(20)+w(10)]

P7: by folding cl 26 in P6 using cl 16
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13)),(14,w(14)),(15,w(15)),(25,w(25)),(27,w(26)),(22,w(22)),(23,w(23)),(18,w(18)),(19,w(19))]
CCS            :[w(20)=:=w(16)+w(12),w(21)=:=w(16)+w(13),w(22)=:=w(17)+w(10),w(23)=:=w(17)+w(11),w(24)=:=w(21)+w(11),w(25)=:=w(20)+w(10),w(26)=<w(24)-w(16)]

P8: by SYMMETRIC folding cl 23 in P7 using cl 17
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13)),(14,w(14)),(15,w(15)),(25,w(25)),(27,w(26)),(22,w(22)),(28,w(27)),(18,w(18)),(19,w(19))]
CCS            :[w(20)=:=w(16)+w(12),w(21)=:=w(16)+w(13),w(22)=:=w(17)+w(10),w(23)=:=w(17)+w(11),w(24)=:=w(21)+w(11),w(25)=:=w(20)+w(10),w(26)=<w(24)-w(16),w(27)=:=w(23)-w(17)]

Final:
25. new3(A,[]).				% w(25)
27. new3(A,[B|C]) :- A=<B, new3(B,C).	% w(26)
22. new4(A,[]).				% w(22)
28. new4(A,[B|C]) :- A=<B, new4(B,C).	% w(27)
*/

% Law 3
new5(A,B,C,D) :- insert(A,C,D), ordered([B|D]).		% w(7)
new6(A,B,C,D) :- A>=B, insert(A,C,D), ordered([B|D]).	% w(8)

