
new1(S,L) :- frontier(S,L).							% W1
new2(S,L) :- frontier(S,L1),a(L1,[],L).					% W2

frontier(tree(T1,T2),L) :- frontier(T1,L1), frontier(T2,L2), a(L1,L2,L).	% W3
frontier(tip(A),[A]).								% W4

a([],L,L) :- list(L).							% W5
a([H|T],L,[H|S]) :- a(T,L,S).						% W6

new3(A,B,E) :- a(A,B,C),a(C,[],E).	% W7
new4(A,B,E) :- a(A,B,E).		% W8

new5(A,B) :- a(A,[],B).		% W9
new6(A,B) :- a([],A,B).		% W10

list([]).				% W11
list([_|T]) :- list(T).		% W12

% LAW 1
law(([a(L1,L2,L3),a(L3,[],L)],[a(L1,[],L4),a(L2,[],L5),a(L4,L5,L)]),(u(8)-u(7)),[u(8)=:=(u(7)-w(5)),u(7)>=(1-w(5)),w(6)>=1]).

% LAW 2 Associativity of a/3
law(([a(L1,L2,T),a(T,L3,L)],[a(L2,L3,M),a(L1,M,L)]),(u(2)-u(1)),[u(1)>=u(2),(u(1)+w(5))>=1,w(6)>=1,(u(2)+w(5))>=1]).

% LAW 3 Associativity of a/3 SYMMETRICAL
law(([a(L1,L2,T),a(T,L3,L)],[a(L2,L3,M),a(L1,M,L)]),(u(2)-u(1)),[u(1)=:=u(2),(u(1)+w(5))>=1,w(6)>=1,(u(2)+w(5))>=1]).

/*
LAW: frontier(S,L) ==> frontier(S,L1),append(L1,[],L)

P1: Progs/law1_frontiers.pl

P2: by unfolding cl 1 in P1 wrt atom 1 using P1
Clause weights :[(13,w(13)),(14,w(14)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4)]

P3: by unfolding cl 2 in P2 wrt atom 1 using P1
Clause weights :[(13,w(13)),(14,w(14)),(15,w(15)),(16,w(16)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4)]

P4: by unfolding cl 16 in P3 wrt atom 1 using P1
Clause weights :[(13,w(13)),(14,w(14)),(15,w(15)),(17,w(17)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4),w(17)=:=w(16)+w(6)]

P5: by unfolding cl 17 in P4 wrt atom 1 using P1
Clause weights :[(13,w(13)),(14,w(14)),(15,w(15)),(18,w(18)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4),w(17)=:=w(16)+w(6),w(18)=:=w(17)+w(5)]

P6: by unfolding cl 18 in P5 wrt atom 1 using P1
Clause weights :[(13,w(13)),(14,w(14)),(15,w(15)),(19,w(19)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4),w(17)=:=w(16)+w(6),w(18)=:=w(17)+w(5),w(19)=:=w(18)+w(11)]

P7: by replacing atoms [3,4] in cl 15 in P6 using law 3 (SYMMETRICAL associativity of a/3)
Clause weights :[(13,w(13)),(14,w(14)),(20,w(20)),(19,w(19)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4),w(17)=:=w(16)+w(6),w(18)=:=w(17)+w(5),w(19)=:=w(18)+w(11),w(20)=:=w(15)+(u(2)-u(1)),u(1)=:=u(2),u(1)+w(5)>=1,w(6)>=1,u(2)+w(5)>=1]

P8: by moving atom from position 1 to position 4 in cl 20 in P7
Clause weights :[(13,w(13)),(14,w(14)),(21,w(20)),(19,w(19)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4),w(17)=:=w(16)+w(6),w(18)=:=w(17)+w(5),w(19)=:=w(18)+w(11),w(20)=:=w(15)+(u(2)-u(1)),u(1)=:=u(2),u(1)+w(5)>=1,w(6)>=1,u(2)+w(5)>=1]

P9: by folding cl 21 in P8 using cl 2
Clause weights :[(13,w(13)),(14,w(14)),(22,w(21)),(19,w(19)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4),w(17)=:=w(16)+w(6),w(18)=:=w(17)+w(5),w(19)=:=w(18)+w(11),w(20)=:=w(15)+(u(2)-u(1)),u(1)=:=u(2),u(1)+w(5)>=1,w(6)>=1,u(2)+w(5)>=1,w(21)=<w(20)-w(2)]

P10: by moving atom from position 1 to position 3 in cl 13 in P9
Clause weights :[(23,w(13)),(14,w(14)),(22,w(21)),(19,w(19)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4),w(17)=:=w(16)+w(6),w(18)=:=w(17)+w(5),w(19)=:=w(18)+w(11),w(20)=:=w(15)+(u(2)-u(1)),u(1)=:=u(2),u(1)+w(5)>=1,w(6)>=1,u(2)+w(5)>=1,w(21)=<w(20)-w(2)]

P11: by folding cl 23 in P10 using cl 1
Clause weights :[(24,w(22)),(14,w(14)),(22,w(21)),(19,w(19)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4),w(17)=:=w(16)+w(6),w(18)=:=w(17)+w(5),w(19)=:=w(18)+w(11),w(20)=:=w(15)+(u(2)-u(1)),u(1)=:=u(2),u(1)+w(5)>=1,w(6)>=1,u(2)+w(5)>=1,w(21)=<w(20)-w(2),w(22)=:=w(13)-w(1)]

Final:
24. new1(tree(A,B),C) :- new1(B,D), a(E,D,C), frontier(A,E).
14. new1(tip(A),[A]).
22. new2(tree(A,B),C) :- new2(B,D), a(E,D,C), frontier(A,E).
19. new2(tip(A),[A]).

Constraint after adding 24>=22 and 14>=19:
Clause weights :[(24,w(22)),(14,w(14)),(22,w(21)),(19,w(19)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12))]
CCS            :[w(13)=:=w(1)+w(3),w(14)=:=w(1)+w(4),w(15)=:=w(2)+w(3),w(16)=:=w(2)+w(4),w(17)=:=w(16)+w(6),w(18)=:=w(17)+w(5),w(19)=:=w(18)+w(11),w(20)=:=w(15)+(u(2)-u(1)),u(1)=:=u(2),u(1)+w(5)>=1,w(6)>=1,u(2)+w(5)>=1,w(21)=<w(20)-w(2),w(22)=<w(13)-w(1),w(22)>=w(21),w(14)>=w(19),w(22)>=1,w(14)>=1,w(22)>=1,w(19)>=1]

w.r.t. the current program, the simplified constraints are:
{(w(11)+w(5)+w(6)+u(2))>=<u(1),w(3)>=1,(u(1)+w(4))>=1,(u(2)+w(11)+w(5)+w(6)+w(4))>=1}
*/

