
new1(L,R) :- r(L,R).

new2(L,R) :- r(L,R1), a(R1,[],R).

r([],[]).
r([H|T],L) :- r(T,V), a(V,[H],L).

a([],L,L).
a([H|T],L,[H|S]) :- a(T,L,S).

new3(L1,L2,L3,L) :- a(L1,L2,M), a(M,L3,L).
new4(L1,L2,L3,L) :- a(L2,L3,R), a(L1,R,L).

% LAW1 - associativity of append/3
% Liberal
law(([a(L1,L2,T),a(T,L3,L)],[a(L2,L3,M),a(L1,M,L)]),(u(2)-u(1)),[u(1)>=u(2)]).
% Strict
% law(([a(L1,L2,T),a(T,L3,L)],[a(L2,L3,M),a(L1,M,L)]),(u(2)-u(1)),[u(1)>=u(2),(u(1)+w(3))>=1,w(4)>=1,(u(2)+w(3))>=1]).

/*
Final Program:

7. new1([],[]).
8. new1([A|B],C) :- r(B,D), a(D,[A],C).
11. new2([],[]).
14. new2([A|B],C) :- r(B,D), a(D,[A],C).
3. r([],[]).
4. r([A|B],C) :- r(B,D), a(D,[A],C).
5. a([],A,A).
6. a([A|B],C,[A|D]) :- a(B,C,D).

After adding appropriate Unfold/Fold-proof conditions

Clause weights :[(7,w(7)),(8,w(8)),(11,w(11)),(14,w(14)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6))]
CCS            :[w(7)=:=w(1)+w(3),w(8)=:=w(1)+w(4),w(9)=:=w(2)+w(3),w(10)=:=w(2)+w(4),w(11)=:=w(9)+w(5),w(12)=:=w(
10)+(u(2)-u(1)),u(1)>=u(2),w(13)=:=w(12)+w(6),w(14)=:=w(13)+w(5),u(1)=:=u(2),w(7)>=w(11),w(8)>=w(14)]
The current Correctness Constraints System is:
Clause weights :[(7,A),(8,B),(11,C),(14,D),(3,E),(4,F),(5,G),(6,H)]
Constraint     :{A=:=I+E,B=:=I+F,J=:=K+E,L=:=K+F,C=:=J+G,M=:=L+(N-O),O>=N,P=:=M+H,D=:=P+G,O=:=N,A>=C,B>=D,A>=1,B>=
1,C>=1,D>=1,E>=1,F>=1,G>=1,H>=1,A>=0,B>=0,C>=0,D>=0,E>=0,F>=0,G>=0,H>=0,I>=0,J>=0,K>=0,L>=0,M>=0,N>=0,O>=0,P>=0}
Clause number 7 weight 3
Clause number 8 weight 3
Clause number 11 weight 2
Clause number 14 weight 3
Clause number 3 weight 1
Clause number 4 weight 1
Clause number 5 weight 1
Clause number 6 weight 1

*/


