% UNFOLD/FOLD PROOF FOR LAW 2 and 3 of INSERTION SORT

new1(B,C) :- list(C),ordered([B|C]).			% w(1)
new2(B,C) :- ordered([B|C]).				% w(2)

p.	% dummy

insert(A,X,[A|X]) :- list(X).				% w(4)
insert(A,[B|X],[B|Y]) :- insert(A,X,Y).			% w(5)

q.	% dummy

new3(A,B,C,D) :- insert(A,C,D), ordered([B|D]).		% w(7)
new4(A,B,C,D) :- A>=B, insert(A,C,D), ordered([B|D]).	% w(8)

ordered([]).						% w(9)
ordered([_]).						% w(10)
ordered([X,Y|L]) :- X =<Y, ordered([Y|L]).		% w(11)

list([]).						% w(12)
list([_|T]) :- list(T).					% w(13)


/*

% LAW 1
new1(B,C) :- list(C),ordered([B|C]).			% w(1)
new2(B,C) :- ordered([B|C]).				% w(2)


PROOF:

P1: Progs/law2-3_insertion_sort.pl
P2: by unfolding cl 1 in P1 wrt atom 1 using P1
Clause weights :[(14,w(14)),(15,w(15)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(1)+w(12),w(15)=:=w(1)+w(13)]

P3: by unfolding cl 2 in P2 wrt atom 1 using P1
Clause weights :[(14,w(14)),(15,w(15)),(16,w(16)),(17,w(17)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(1)+w(12),w(15)=:=w(1)+w(13),w(16)=:=w(2)+w(10),w(17)=:=w(2)+w(11)]

P4: by unfolding cl 15 in P3 wrt atom 2 using P1
Clause weights :[(14,w(14)),(18,w(18)),(16,w(16)),(17,w(17)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(1)+w(12),w(15)=:=w(1)+w(13),w(16)=:=w(2)+w(10),w(17)=:=w(2)+w(11),w(18)=:=w(15)+w(11)]

P5: by moving atom from position 1 to position 2 in cl 18 in P4
Clause weights :[(14,w(14)),(19,w(18)),(16,w(16)),(17,w(17)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(1)+w(12),w(15)=:=w(1)+w(13),w(16)=:=w(2)+w(10),w(17)=:=w(2)+w(11),w(18)=:=w(15)+w(11)]

P6: by folding cl 19 in P5 using cl 1
Clause weights :[(14,w(14)),(20,w(19)),(16,w(16)),(17,w(17)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(1)+w(12),w(15)=:=w(1)+w(13),w(16)=:=w(2)+w(10),w(17)=:=w(2)+w(11),w(18)=:=w(15)+w(11),w(19)=<w(18)-w(1)]

P7: by folding cl 17 in P6 using cl 2
Clause weights :[(14,w(14)),(20,w(19)),(16,w(16)),(21,w(20)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(1)+w(12),w(15)=:=w(1)+w(13),w(16)=:=w(2)+w(10),w(17)=:=w(2)+w(11),w(18)=:=w(15)+w(11),w(19)=<w(18)-w(1),w(20)=<w(17)-w(2)]

P8: by unfolding cl 14 in P7 wrt atom 1 using P1
Clause weights :[(22,w(21)),(20,w(19)),(16,w(16)),(21,w(20)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(1)+w(12),w(15)=:=w(1)+w(13),w(16)=:=w(2)+w(10),w(17)=:=w(2)+w(11),w(18)=:=w(15)+w(11),w(19)=<w(18)-w(1),w(20)=<w(17)-w(2),w(21)=:=w(14)+w(10)]

*/

/*
% LAW 2:

P1: Progs/law2-3_insertion_sort.pl
P2: by unfolding cl 7 in P1 wrt atom 2 using P1
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(14,w(14)),(15,w(15)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(7)+w(10),w(15)=:=w(7)+w(11)]

P3: by unfolding cl 8 in P2 wrt atom 3 using P1
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(14,w(14)),(15,w(15)),(16,w(16)),(17,w(17)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(7)+w(10),w(15)=:=w(7)+w(11),w(16)=:=w(8)+w(10),w(17)=:=w(8)+w(11)]

P4: by deleting cl 14 in P3
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(15,w(15)),(16,w(16)),(17,w(17)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(7)+w(10),w(15)=:=w(7)+w(11),w(16)=:=w(8)+w(10),w(17)=:=w(8)+w(11)]

P5: by deleting cl 16 in P4
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(15,w(15)),(17,w(17)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(7)+w(10),w(15)=:=w(7)+w(11),w(16)=:=w(8)+w(10),w(17)=:=w(8)+w(11)]

P6: by unfolding cl 15 in P5 wrt atom 1 using P1
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(18,w(18)),(19,w(19)),(17,w(17)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(7)+w(10),w(15)=:=w(7)+w(11),w(16)=:=w(8)+w(10),w(17)=:=w(8)+w(11),w(18)=:=w(15)+w(4),w(19)=:=w(15)+w(5)]

P7: by unfolding cl 17 in P6 wrt atom 2 using P1
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(18,w(18)),(19,w(19)),(20,w(20)),(21,w(21)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(7)+w(10),w(15)=:=w(7)+w(11),w(16)=:=w(8)+w(10),w(17)=:=w(8)+w(11),w(18)=:=w(15)+w(4),w(19)=:=w(15)+w(5),w(20)=:=w(17)+w(4),w(21)=:=w(17)+w(5)]

P8: by moving atom from position 3 to position 1 in cl 21 in P7
Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(18,w(18)),(19,w(19)),(20,w(20)),(22,w(21)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(13,w(13))]
CCS            :[w(14)=:=w(7)+w(10),w(15)=:=w(7)+w(11),w(16)=:=w(8)+w(10),w(17)=:=w(8)+w(11),w(18)=:=w(15)+w(4),w(19)=:=w(15)+w(5),w(20)=:=w(17)+w(4),w(21)=:=w(17)+w(5)]

SONO ARRIVATO FIN QUI:

18. new3(A,B,C,[A|C]) :- list(C), B=<A, ordered([A|C]).
19. new3(A,B,[C|D],[C|E]) :- insert(A,D,E), B=<C, ordered([C|E]).
20. new4(A,B,C,[A|C]) :- A>=B, list(C), B=<A, ordered([A|C]).
22. new4(A,B,[C|D],[C|E]) :- B=<C, A>=B, insert(A,D,E), ordered([C|E]).

*/

