
r([],[]).				% W1
r([H|T],L) :- r(T,V), a(V,[H],L).	% W2

a([],L,L).				% W3
a([H|T],L,[H|R]) :- a(T,L,R).		% W4

% LAW1 - distributivity of null element for concatenation over r/2
% Liberal
%  law(([r(L,R)],[r(L,R1), a(R1,[],R)]),(u(2)-u(1)),[u(1)>=(u(2)+w(3)),u(1)>=(w(3)+w(4)+u(2))]).
% Strict
law(([r(L,R)],[r(L,R1), a(R1,[],R)]),(u(2)-u(1)),[u(1)>=(u(2)+w(3)),u(1)>=(w(3)+w(4)+u(2)),(u(1)+w(1))>=1,(u(1)+w(2))>=1,(u(2)+w(2)+w(3))>=1,(w(3)+w(4)+u(2)+w(2))>=1]).


% LAW2 - associativity of append/3
% Liberal
%  law(([a(L1,L2,T),a(T,L3,L)],[a(L2,L3,M),a(L1,M,L)]),(u(4)-u(3)),[u(3)>=u(4)]).
% Strict
law(([a(L1,L2,T),a(T,L3,L)],[a(L2,L3,M),a(L1,M,L)]),(u(4)-u(3)),[u(3)>=u(4),(u(3)+w(3))>=1,w(4)>=1,(u(4)+w(3))>=1]).

/*

% COMPUTED CONSTRAINT :

| ?- solve_constr.
Clause weights :[(1,w(1)),(13,w(13)),(3,w(3)),(4,w(4)),(8,w(8)),(12,w(12))]
CCS            :[w(6)=:=w(5)+w(1),w(7)=:=w(5)+w(2),w(8)=:=w(6)+w(3),w(9)=:=w(7)+(u(2)-u(1)),u(1)>=u(2),w(10)=:=w(9)+w(4),w(11)=:=w(10)+w(3),w(12)=<w(11)-w(5),w(13)=<w(2)-w(5)]
The actual constraints system is the following:
Clause weights :[(1,A),(13,B),(3,C),(4,D),(8,E),(12,F)]
Constraint     :{G=:=H+A,I=:=H+J,E=:=G+C,K=:=I+(L-M),M>=L,N=:=K+D,O=:=N+C,F=<O-H,B=<J-H,A>=1,B>=1,C>=1,D>=1,E>=1,F>=1,A>=0,B>=0,C>=0,D>=0,E>=0,F>=0,G>=0,H>=0,I>=0,J>=0,K>=0,L>=0,M>=0,N>=0,O>=0}
Clause number 1 weight 1
Clause number 13 weight 1
Clause number 3 weight 1
Clause number 4 weight 1
Clause number 8 weight 2
Clause number 12 weight 1

% FINAL PROGRAM
| ?- p.
1. r([],[]).
13. r([A|B],C) :- genr(B,C,[A]).
3. a([],A,A).
4. a([A|B],C,[A|D]) :- a(B,C,D).
8. genr([],A,A).
12. genr([A|B],C,D) :- genr(B,C,[A|D]).

*/
