
% example taken from Roychoudhury-Ramakrishnan

thm(X) :- gen(X), test(X).				% w(1)

gen([]).								% w(2)
gen([0|X]) :- gen(X).					% w(3)

test(X) :- canon(X).					% w(4)
test(X) :- trans(X,Y), test(Y).			% w(5)

canon([]).								% w(6)
canon([1|X]) :- canon(X).				% w(7)

trans([0|X],[1|X]).						% w(8)
trans([1|T],[1|T1]) :- trans(T,T1).		% w(9)

test1(A) :- test([1|A]).				% w(10)

new1(X) :- test(X).						% w(11)

new2(X) :- test1(X).					% w(12)


% what if we add
%  trans([0|T],[0|T1]) :- trans(T,T1).
% that is, some nondeterminism?

% LAW 1
%%%new1(Y) :- test([1|Y]).
%%%new2(Y) :- test(Y).
%liberal
% law(([test([1|Y])],[test(Y)]),(u(2)-u(1)),[(w(7)+u(1))>=u(2),w(9)>=1]).
%strict
% law(([test([1|Y])],[test(Y)]),(u(2)-u(1)),[(w(7)+u(1))>=u(2),w(9)>=1,(w(7)+w(4)+u(1))>=1,(w(9)+w(5))>=1,(w(4)+u(2))>=1,w(5)>=1]).

/*
P1: Progs/theorem_ramakrishnan.pl
P2: by unfolding cl 10 in P1 wrt atom 1 using P1
[w(12)=:=w(10)+w(4),w(13)=:=w(10)+w(5)]

P3: by unfolding cl 11 in P2 wrt atom 1 using P1
[w(12)=:=w(10)+w(4),w(13)=:=w(10)+w(5),w(14)=:=w(11)+w(4),w(15)=:=w(11)+w(5)]

P4: by unfolding cl 12 in P3 wrt atom 1 using P1
[w(12)=:=w(10)+w(4),w(13)=:=w(10)+w(5),w(14)=:=w(11)+w(4),w(15)=:=w(11)+w(5),w(16)=:=w(12)+w(7)]

P5: by unfolding cl 13 in P4 wrt atom 1 using P1
[w(12)=:=w(10)+w(4),w(13)=:=w(10)+w(5),w(14)=:=w(11)+w(4),w(15)=:=w(11)+w(5),w(16)=:=w(12)+w(7),w(17)=:=w(13)+w(9)]

P6: by folding cl 17 in P5 using cl 10
[w(12)=:=w(10)+w(4),w(13)=:=w(10)+w(5),w(14)=:=w(11)+w(4),w(15)=:=w(11)+w(5),w(16)=:=w(12)+w(7),w(17)=:=w(13)+w(9),w(18)=<w(17)-w(10)]

P7: by folding cl 15 in P6 using cl 11
[w(12)=:=w(10)+w(4),w(13)=:=w(10)+w(5),w(14)=:=w(11)+w(4),w(15)=:=w(11)+w(5),
w(16)=:=w(12)+w(7),w(17)=:=w(13)+w(9),w(18)=<w(17)-w(10),w(19)=<w(15)-w(11)]

To verify correctness of the unfold/fold proof,
add_to_current([(w(7)+w(10))>=w(11), w(9)>=0,w(19)=:=w(15)-w(11)]).
Final program:
16. new1(A) :- canon(A).
18. new1(A) :- trans(A,B), new1(B).
14. new2(A) :- canon(A).
19. new2(A) :- trans(A,B), new2(B).

Clause number 16 weight 2
Clause number 18 weight 1
Clause number 14 weight 1
Clause number 19 weight 1
*/

% test(A) -> test1(A)
%%% law(([test(A)],[test1(A)]),w(12)-w(11),[w(7)+w(10)-w(11)+w(12)=<rat(0,1),w(9)=<rat(0,1)],normal).
% test1(A) -> test(A)
law(([test1(A)],[test(A)]),w(11)-w(12),[w(7)+w(10)-w(11)+w(12)>=rat(0,1),w(9)>=rat(0,1)],normal).