
% example taken from tamaki-sato 1985

/*
Final Program:

23. sol(A,[B|C]) :- sol_1(B,A,C,1).
19. sol([],[]).
40. sol_1(A,B,[C|D],E) :- del(B,A,F), sol_1(C,F,D,1), del(B,C,G), 
          sol_1(A,G,D,s(E)), noattack(A,C,E).
26. sol_1(A,[A|B],[],C) :- sol(B,[]).
*/

perm(L,[Q|M]) :- del(L,Q,L1), perm(L1,M).			% W1
perm([],[]).							% W2	% why b.c. placed after?

% del(X,H,Z) :-: e([A],a(A,[H|Z],X)).
del([X|Y],X,Y).							% W3
del([H|X],Y,[H|Z]) :- del(X,Y,Z).				% W4

safe([Q|L]) :- nodiag(Q,L,1), safe(L).				% W5
safe([]).							% W6	% here the same

nodiag(Q1,[Q2|L],N) :- noattack(Q1,Q2,N),nodiag(Q1,L,s(N)).	% W7
nodiag(Q1,[],N).						% W8

noattack(Q1,Q2,N) :- Q1>Q2, Diff is Q1-Q2, Diff \== N.	% W9
noattack(Q1,Q2,N) :- Q1<Q2, Diff is Q2-Q1, Diff \== N.	% W10

rev_ap(X,[],X).							% W11
rev_ap(X,[H|Y],Z) :- rev_ap([H|X],Y,Z).			% W12

% defs:
sol(L,Perm) :- perm(L,Perm), safe(Perm).			% W13
sol_1(Q,L,M,N) :- del(L,Q,L1), sol(L1,M), nodiag(Q,M,N).	% W14

% LAW 1: associativity of del/3
new1(L,Q1,Q2,LN) :- del(L,Q1,L2), del(L2,Q2,LN).
new2(L,Q1,Q2,LN) :- del(L,Q2,L3), del(L3,Q1,LN).
% liberal
% law(([del(L,Q1,L2), del(L2,Q2,LN)],[del(L,Q2,L3), del(L3,L1,LN)]),(u(2)-u(1)),[u(1)>=(w(4)+u(2)),(w(4)+u(1))>=u(2)]).
% strict
law(([del(L,Q1,L2),del(L2,Q2,LN)],[del(L,Q1,L2),del(L2,Q2,LN),del(L,Q2,L3),del(L3,Q1,LN)]),(u(2)+u(1)),[u(1)>=(w(4)+u(2)),(w(4)+u(1))>=u(2),(u(1)+w(3))>=1,(w(3)+w(4)+u(1))>=1,(w(4)+w(4))>=1,(w(3)+w(4)+u(2))>=1,(w(3)+u(2))>=1]).

% LAW 2: duplicate goals
law(([sol(X,Y)],[sol(X,Y),sol(X,Y)]),w(13),[]).

% LAW 1: associativity of del/3
new3(L,Q1,Q2,M) :- del(L,Q1,L1), del(L1,Q2,L2), sol(L2,M).
new4(L,Q1,Q2,M) :- del(L,Q1,L1), del(L1,Q2,L2), sol(L2,M), del(L,Q2,L3), del(L3,Q1,L4), sol(L4,M).
% liberal
% law(([del(L,Q1,L2), del(L2,Q2,LN)],[del(L,Q2,L3), del(L3,L1,LN)]),(u(2)-u(1)),[u(1)>=(w(4)+u(2)),(w(4)+u(1))>=u(2)]).
% strict
% law(([del(L,Q1,L2),del(L2,Q2,LN)],[del(L,Q1,L2),del(L2,Q2,LN),del(L,Q2,L3),del(L3,Q1,LN)]),(u(2)+u(1)),[u(1)>=(w(4)+u(2)),(w(4)+u(1))>=u(2),(u(1)+w(3))>=1,(w(3)+w(4)+u(1))>=1,(w(4)+w(4))>=1,(w(3)+w(4)+u(2))>=1,(w(3)+u(2))>=1]).


/*
P1: Progs/ts_8-queen.pl
P2: by unfolding cl 13 in P1 wrt atom 1 using P1
[w(15)=:=w(13)+w(3),w(16)=:=w(13)+w(4)]

P3: by unfolding cl 16 in P2 wrt atom 2 using P1
[w(15)=:=w(13)+w(3),w(16)=:=w(13)+w(4),w(17)=:=w(16)+w(3),w(18)=:=w(16)+w(4)]

P4: by folding cl 18 in P3 using cl 13
[w(15)=:=w(13)+w(3),w(16)=:=w(13)+w(4),w(17)=:=w(16)+w(3),w(18)=:=w(16)+w(4),w(19)=<w(18)-w(13)]

P5: by unfolding cl 14 in P4 wrt atom 1 using P1
[w(15)=:=w(13)+w(3),w(16)=:=w(13)+w(4),w(17)=:=w(16)+w(3),w(18)=:=w(16)+w(4),w(19)=<w(18)-w(13),w(20)=:=w(14)+w(3),w(21)=:=w(14)+w(4)]

P6: by unfolding cl 21 in P5 wrt atom 2 using P1
[w(15)=:=w(13)+w(3),w(16)=:=w(13)+w(4),w(17)=:=w(16)+w(3),w(18)=:=w(16)+w(4),w(19)=<w(18)-w(13),w(20)=:=w(14)+w(3),w(21)=:=w(14)+w(4),w(22)=:=w(21)+w(3),w(23)=:=w(21)+w(4)]

P7: by folding cl 23 in P6 using cl 14
[w(15)=:=w(13)+w(3),w(16)=:=w(13)+w(4),w(17)=:=w(16)+w(3),w(18)=:=w(16)+w(4),w(19)=<w(18)-w(13),w(20)=:=w(14)+w(3),w(21)=:=w(14)+w(4),w(22)=:=w(21)+w(3),w(23)=:=w(21)+w(4),w(24)=<w(23)-w(14)]

Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(12,w(12)),(15,w(15)),(17,w(17)),(19,w(19)),(20,w(20)),(22,w(22)),(24,w(24))]
CCS            :[w(15)=:=w(13)+w(3),w(16)=:=w(13)+w(4),w(17)=:=w(16)+w(3),w(18)=:=w(16)+w(4),w(19)=<w(18)-w(13),w(20)=:=w(14)+w(3),w(21)=:=w(14)+w(4),w(22)=:=w(21)+w(3),w(23)=:=w(21)+w(4),w(24)=<w(23)-w(14)]

The current Correctness Constraints System is:
Clause weights :[(1,A),(2,B),(3,C),(4,D),(5,E),(6,F),(7,G),(8,H),(9,I),(10,J),(11,K),(12,L),(15,M),(17,N),(19,O),(20,P),(22,Q),(24,R)]
Constraint     :{M=:=S+C,T=:=S+D,N=:=T+C,U=:=T+D,O=<U-S,P=:=V+C,W=:=V+D,Q=:=W+C,X=:=W+D,R=<X-V,A>=1,B>=1,C>=1,D>=1,E>=1,F>=1,G>=1,H>=1,I>=1,J>=1,K>=1,L>=1,M>=1,N>=1,O>=1,P>=1,Q>=1,R>=1,C>=0,D>=0,M>=0,N>=0,O>=0,P>=0,Q>=0,R>=0,S>=0,T>=0,U>=0,V>=0,W>=0,X>=0}

Clause number 1 weight 1
Clause number 2 weight 1
Clause number 3 weight 1
Clause number 4 weight 1
Clause number 5 weight 1
Clause number 6 weight 1
Clause number 7 weight 1
Clause number 8 weight 1
Clause number 9 weight 1
Clause number 10 weight 1
Clause number 11 weight 1
Clause number 12 weight 1
Clause number 15 weight 1
Clause number 17 weight 2
Clause number 19 weight 1
Clause number 20 weight 1
Clause number 22 weight 2
Clause number 24 weight 1
*/

% LAW 2: commutativity of rev_ap/3
% new3(L,Q1,Q2,LN) :- del(L,Q1,L2), del(L2,Q2,LN).
% new4(L,Q1,Q2,LN) :- del(L,Q2,L3), del(L3,L1,LN).
%
% law(([del(L,Q1,L2), del(L2,Q2,LN)],[del(L,Q2,L3), del(L3,L1,LN)]),(u(2)-u(1)),[]).

