
% examples taken from tamaki-sato examples 1985

% EX1: initial(or prefix)
append([],L,L).
append([H|T],L,[H|R]) :- append(T,L,R).

% EX2: lenght_inter
len([],0).
len([H|L],s(N)) :- len(L,N).

mem(H,[H|L]).
mem(H,[X|L]) :- mem(H,L).

not_mem(_,[]).
not_mem(H,[X|L]) :- H\==X, not_mem(H,L).


intersection([],Y,[]).
intersection([A|X],Y,[A|Z]) :- mem(A,Y), intersection(X,Y,Z).
intersection([A|X],Y,Z) :- not_mem(A,Y), intersection(X,Y,Z).

% EX3: 

/*
% EX1 - INITIAL:
P1: Progs/ts_examples.pl

P2: by adding def 3 to P1
3. initial(A,B) :- append(A,C,B).
[]

P3: by unfolding cl 3 in P2 wrt atom 1 using P1
4. initial([],A).
5. initial([A|B],[A|C]) :- append(B,D,C).
[w(4)=:=w(3)+w(1),w(5)=:=w(3)+w(2)]

P4: by folding cl 5 in P3 using cl 3
6. initial([A|B],[A|C]) :- initial(B,C).
[w(4)=:=w(3)+w(1),w(5)=:=w(3)+w(2),w(6)=<w(5)-w(3)]

Final:
4. initial([],A).
6. initial([A|B],[A|C]) :- initial(B,C).

| ?- solve_constr. 

Clause weights :[(1,w(1)),(2,w(2)),(4,w(4)),(6,w(6))]
CCS            :[w(4)=:=w(3)+w(1),w(5)=:=w(3)+w(2),w(6)=<w(5)-w(3)]

The current Correctness Constraints System is:
Clause weights :[(1,A),(2,B),(4,C),(6,D)]
Constraint     :{C=:=E+A,F=:=E+B,D=<F-E,A>=1,B>=1,C>=1,D>=1,A>=0,B>=0,C>=0,D>=0,E>=0,F>=0}

Clause number 1 weight 1
Clause number 2 weight 1
Clause number 4 weight 1
Clause number 6 weight 1
*/

/*
% EX2 - lenght_inter/3

P1: Progs/ts_examples.pl
P2: by adding def 12 to P1
12. lenght_inter(A,B,C) :- intersection(A,B,D), len(D,C).
[]

P3: by unfolding cl 12 in P2 wrt atom 1 using P1
[w(13)=:=w(12)+w(9),w(14)=:=w(12)+w(10),w(15)=:=w(12)+w(11)]

P4: by unfolding cl 13 in P3 wrt atom 1 using P1
[w(13)=:=w(12)+w(9),w(14)=:=w(12)+w(10),w(15)=:=w(12)+w(11),w(16)=:=w(13)+w(3)]

P5: by unfolding cl 14 in P4 wrt atom 3 using P1
[w(13)=:=w(12)+w(9),w(14)=:=w(12)+w(10),w(15)=:=w(12)+w(11),w(16)=:=w(13)+w(3),w(17)=:=w(14)+w(4)]

P6: by folding cl 17 in P5 using cl 12
[w(13)=:=w(12)+w(9),w(14)=:=w(12)+w(10),w(15)=:=w(12)+w(11),w(16)=:=w(13)+w(3),w(17)=:=w(14)+w(4),w(18)=<w(17)-w(12)]

P7: by folding cl 15 in P6 using cl 12
[w(13)=:=w(12)+w(9),w(14)=:=w(12)+w(10),w(15)=:=w(12)+w(11),w(16)=:=w(13)+w(3),w(17)=:=w(14)+w(4),w(18)=<w(17)-w(12),w(19)=<w(15)-w(12)]

16. lenght_inter([],A,0).
18. lenght_inter([A|B],C,s(D)) :- mem(A,C), lenght_inter(B,C,D).
19. lenght_inter([A|B],C,D) :- not_mem(A,C), lenght_inter(B,C,D).

Clause weights :[(1,w(1)),(2,w(2)),(3,w(3)),(4,w(4)),(5,w(5)),(6,w(6)),(7,w(7)),(8,w(8)),(9,w(9)),(10,w(10)),(11,w(11)),(16,w(16)),(18,w(18)),(19,w(19))]
CCS            :[w(13)=:=w(12)+w(9),w(14)=:=w(12)+w(10),w(15)=:=w(12)+w(11),w(16)=:=w(13)+w(3),w(17)=:=w(14)+w(4),w(18)=<w(17)-w(12),w(19)=<w(15)-w(12)]
The current Correctness Constraints System is:
Clause weights :[(1,A),(2,B),(3,C),(4,D),(5,E),(6,F),(7,G),(8,H),(9,I),(10,J),(11,K),(16,L),(18,M),(19,N)]
Constraint     :{O=:=P+I,Q=:=P+J,R=:=P+K,L=:=O+C,S=:=Q+D,M=<S-P,N=<R-P,A>=1,B>=1,C>=1,D>=1,E>=1,F>=1,G>=1,H>=1,I>=1,J>=1,K>=1,L>=1,M>=1,N>=1,C>=0,D>=0,I>=0,J>=0,K>=0,L>=0,M>=0,N>=0,O>=0,P>=0,Q>=0,R>=0,S>=0}
Clause number 1 weight 1
Clause number 2 weight 1
Clause number 3 weight 1
Clause number 4 weight 1
Clause number 5 weight 1
Clause number 6 weight 1
Clause number 7 weight 1
Clause number 8 weight 1
Clause number 9 weight 1
Clause number 10 weight 1
Clause number 11 weight 1
Clause number 16 weight 2
Clause number 18 weight 1
Clause number 19 weight 1
*/
