% example taken from tamaki-sato 1985

% a/3
a([],L,L).								% w(1)
a([X|T],L,[X|R]) :- a(T,L,R).						% w(2)

% fringe/2
fringe(tip(A),[A]).							% w(3)
fringe(tree(A,B),L) :- fringe(A,X), fringe(B,Y), a(X,Y,L).		% w(4)

% new1/4
new1(L1,L2,L3,L) :- a(L1,L2,T),a(T,L3,L).				% w(5)
% new2/4
new2(L1,L2,L3,L) :- a(L2,L3,M),a(L1,M,L).				% w(6)

%      COMPUTED LAW 1
% ~ associativity of a/3 ~
%
% OLD liberal
% OLD law(([a(L1,L2,T),a(T,L3,L)],[a(L2,L3,M),a(L1,M,L)]),(u(2)-u(1)),[u(1)>=u(2)]).
% OLD strict
% OLD law(([a(L1,L2,T),a(T,L3,L)],[a(L2,L3,M),a(L1,M,L)]),(u(2)-u(1)),[u(1)>=u(2),(u(1)+w(1))>=1,w(2)>=1,(u(2)+w(1))>=1]).
law(([a(A,B,C),a(C,D,E)],[a(B,D,F),a(A,F,E)]),w(6)-w(5),[w(2)>=rat(0,1),w(5)-w(6)>=rat(0,1)],normal).

% THE TRANSFORMATION FOR FRINGE IS UNSATISFIABLE
% AS THE FINaL CORRECTNESS CONSTRAINT SYSTEM REDUCES TO
%
% A =< B - C
% B =< C
% A,B,C >= 1
%
% WHICH IS UNSATISFIABLE {A =< (B-C), B =< C, A >=1, B >= 1, C >= 1}