
% example taken from tamaki-sato 1985

a([],L,L).								% W1
a([X|T],L,[X|R]) :- a(R,L,T).						% W2

perm([],[]).
perm([A|X],Y) :- perm(X,Z), del(Y,A,Z).

% del(X,H,Z) :-: e([A],a(A,[H|Z],X)).
del([H|X],H,X).
del([H|X],Y,[H|Z]) :- del(X,Y,Z).

% ord(X) :-: a([A,B],e([U,V],(a(U,[A,B|V],X) -> A=<B))).
ord([]).
ord([_]).
ord([A,B|X]) :- A=<B, ord([B|X]).

% NAIVE SORT
n_sort(X,Y) :- perm(X,Y), sort(Y).

% NEW DEFINITIONs
i_sort(X,Y) :- perm(X,Y), sort(Y).
i_sort1(Y,H,Z) :- del(Y,H,Z), ord(Y).

% LAW 1:
% ord(Y),del(Y,H,Z) ==> ord(Y),del(Y,H,Z),ord(Z)
new1(Y,H,Z) :- ord(Y),del(Y,H,Z).
new2(Y,H,Z) :- ord(Y),del(Y,H,Z),ord(Z).

% LAW 2:
% i_sort1([B|Y],H,Z),A=<B ==> i_sort1([B|Y],H,Z),A=<B,H>=A
new3(B,Y,H,Z,A) :- i_sort1([B|Y],H,Z),A=<B.
new4(B,Y,H,Z,A) :- i_sort1([B|Y],H,Z),A=<B,H>=A.

% LAW 3:
law(([X=<Y,Y=<Z],[X=<Y,Y=<Z,X=<Z]),0,[]).

% LAW 4:
law(([X=<Y,Y=<Z,X=<Z],[X=<Y,Y=<Z]),0,[]).

