%m(N,S) :- nat N belongs to set S.  nat are represented as numerals: 
% nat = 0 + s(nat), sets are finite lists of bits (y or n).

m(0,[B|Bs]) :- eq_bit(B,y).
m(s(X),[B|Bs]) :- m(X,Bs).

leq(0,X).
leq(s(X),s(Y)) :- leq(X,Y).

eq_nat(0,0).
eq_nat(s(X),s(Y)) :- eq_nat(X,Y).

eq_bit(n,n).
eq_bit(y,y).


%TYPE DEFINITIONS

bit(n).
bit(y).

list_of_bit([]).
list_of_bit([B|Bs]) :- bit(B), list_of_bit(Bs).

nat(0).
nat(s(X)) :- nat(X).


%TYPE DECLARATIONS

type(m,2,[nat,list_of_bit]).

type(leq,2,[nat,nat]).

type(eq_nat,2,[nat,nat]).

type(eq,2,[bit,bit]).



/*every finite, nonempty set S of nat has a maximum element M
a([S], (e([Y],m(Y,S))->e([M], m(M,S) and a([X],(m(X,S)->leq(X,M)))))).

Proved
*/

/* Synthesis of a program for computing the maximum of a (possibly empty)
set

(e([Y],m(Y,S)) -> m(M,S) and a([X],(m(X,S)->leq(X,M))))
and 
(a([Y], \+ m(Y,S)) -> eq_nat(M,0)).

SUCCEDED
*/

/* for every finite nonempty set S1 there exists a finite set S2 such that:
 S1 /\ S2 = emptyset  
 and  max(S2) < max(S1) 
 and S2 is the greater such a finite set

a([S1], 
 ( e([X], m(X,S1)) -> 
  e([S2],
  (\+ e([X], m(X,S1) and m(X,S2)))

  and

  (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)) ))  ))

  and 

  (a([S3],    
  ( 
  (\+ e([X], m(X,S1) and m(X,S3)))

  and

  (e([Y], m(Y,S1) and (a([Z], (m(Z,S3) -> leq(Z,Y)) ))  ))

   -> (a([X], ( m(X,S3) -> m(X,S2))))  )
  ))
 ) )
).

*/

/* synthesis of new1(S1,S2)  such that S1 and S2 are finite sets:
 S1 /\ S2 = emptyset  
 and  max(S2) < max(S1) 
 and S2 is the greater such a finite set

  (\+ e([X], m(X,S1) and m(X,S2)))

  and

  (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)) ))  ))

  and 

  (a([S3],    
  ( 
  (\+ e([X], m(X,S1) and m(X,S3)))

  and

  (e([Y], m(Y,S1) and (a([Z], (m(Z,S3) -> leq(Z,Y)) ))  ))

   -> (a([X], ( m(X,S3) -> m(X,S2))))  )
  )).

*/

/* every finite set S of nat has a subset R which is the empty set
 a([S],e([R],
a([X],(m(X,R) -> m(X,S))) and a([Y],\+ m(Y,R))
  )).

*/



/* Synthesis of the empty set

a([S], a([X],(m(X,R) -> m(X,S))) and a([Y],\+ m(Y,R))).


*/


/*
subset

a([X],(m(X,R) -> m(X,S)))    % 0.390

a([
*/
