%PROOF OF THE SERIALIZABILITY OF THE 2PL PROTOCOL
%(for 2 transactions and 1 data item) 20-2-98
%[Bernstein et al. 1987, Th. 3.6, p.56]


%SPECIFICATION

% two_p_l_serial :- a([H], (two_p_l(H) -> serializable(H))).

%EQUIVALENT TO

two_p_l_serial :- prove(\+ e([H], two_p_l(H) and ns1(H))).

synth1 :- synth(two_p_l(H),(p31(H) and p32(H) and p33(H))).

%Prop 3.1
synth2 :-
synth(p31(H), a([O2,N2],
 (e([O,OL,OU], member(O2,N2,H) and o(O2,O) and lock(O,OL) and unlock(O,OU))
->
 e([O1,N1,O3,N3,OL,OU,D,T,O],
 member(O1,N1,H) and member(O3,N3,H)
 and o(O1,OL) and o(O3,OU) and d(O1,D) and d(O3,D) and t(O1,T) and t(O3,T)
 and o(O2,O) and lock(O,OL) and unlock(O,OU) and d(O2,D) and t(O2,T)
 and less(N1,N2) and less(N2,N3))))).


%Prop 3.2
synth3 :-
synth(p32(H), a([O1,N1,O2,N2],
(e([Op1,T1,Op2,T2,Op1L,Op1U,Op2L,Op2U,D],
 member(O1,N1,H) and o(O1,Op1) and d(O1,D) and t(O1,T1) and
 member(O2,N2,H) and o(O2,Op2) and d(O2,D) and t(O2,T2) and
 diff_t(T1,T2) and conflicting(O1,O2)
 and lock(Op1,Op1L) and unlock(Op1,Op1U) and lock(Op2,Op2L) and unlock(Op2,Op2U)
)
->
 e([O3,O4,N3,N4,Op1,T1,Op2,T2,Op1L,Op1U,Op2L,Op2U,D],
     member(O3,N3,H) and d(O3,D) and
     member(O4,N4,H) and d(O4,D) and less(N3,N4) and
     o(O1,Op1) and d(O1,D) and t(O1,T1) and
     o(O2,Op2) and t(O2,T2) and
     ( (o(O3,Op1U) and o(O4,Op2L) and t(O3,T1) and t(O4,T2)) or
       (o(O3,Op2U) and o(O4,Op1L) and t(O3,T2) and t(O4,T1)) ) )
))).


%Prop 3.3
synth4 :-
synth(p33(H), a([O1,N1,O2,N2],
( e([Op1,Op2,Op1L,Op2U,T], member(O1,N1,H) and member(O2,N2,H) and
  o(O1,Op1) and o(O2,Op2) and lock(Op1,Op1L) and unlock(Op2,Op2U) and
  t(O1,T) and t(O2,T))
->
 e([O3,N3,O4,N4,Op1,Op2,Op1L,Op2U,D1,D2,T],
  member(O3,N3,H) and member(O4,N4,H)
  and o(O3,Op1L) and o(O4,Op2U)
  and d(O1,D1) and d(O2,D2) and d(O3,D1) and d(O4,D2)
  and t(O1,T) and t(O3,T) and t(O4,T) and
  less(N3,N4))))).


%ns1(H) iff \+ serializable(H)
synth5 :-
synth(ns1(H),e([O1,O2,O3,N1,N2,N3,T1,T2],
member(O1,N1,H) and member(O2,N2,H) and member(O3,N3,H) and
conflicting(O1,O2) and conflicting(O2,O3) and
t(O1,T1) and t(O2,T2) and t(O3,T1) and diff_t(T1,T2) and
less(N1,N2) and less(N2,N3))).
