%Transitions

t(s(I,D,S,E),s(I,D,S,E)) :-
	I>=0,E>=0,D>=0,S>=0,E+D+S>=1.

t(s(I,D,S,E),s(I1,D,S,E1)) :-
	I>=1,D>=0,S>=0,E>=0,
	I1=:=I-1,
	E1=:=E+1.

t(s(I,D,S,E),s(I1,D1,S1,E)) :-
	I>=1,D>=1,S>=0,E>=0,
	I1=:=I-1,
	D1=:=D-1,
	S1=:=S+2.

t(s(I,D,S,E),s(I1,D,S1,E1)) :-
	I>=1,S>=0,E>=0,D>=0,S+E>=1,
	I1=:=I-1,
	S1=:=S+E+1,
	E1=:=0.

t(s(I,D,S,E),s(I,D,S,E)) :-
	I>=0,D>=1,S>=0,E>=0.

t(s(I,D,S,E),s(I,D1,S,E1)) :-
	I>=0,D>=0,S>=0,E>=1,
	D1=:=D+1,
	E1=:=E-1.

t(s(I,D,S,E),s(I1,D1,S1,E)) :-
	I>=0,D>=0,S>=1,E>=0,
      	S1=:=0,
	I1=:=I+D+S-1,
	D1=:=1.

t(s(I,D,S,E),s(I1,D1,S1,E1)) :-
	I>=1,D>=0,S>=0,E>=0,
      	I1=:=E+D+I+S-1,
	E1=:=0,
	S1=:=0,
	D1=:=1.

t(s(I,D,S,E),s(I1,D1,S,E)) :-
	I>=0,D>=1,S>=0,E>=0,
     	I1=:=I+1,
	D1=:=D-1.

t(s(I,D,S,E),s(I1,D,S1,E)) :-
	I>=0,D>=0,S>=1,E>=0,
     	I1=:=I+1,
	S1=:=S-1.

t(s(I,D,S,E),s(I1,D,S,E1)) :-
	I>=0,D>=0,S>=0,E>=1,
     	I1=:=I+1,
	E1=:=E-1.


% Elementary Properties

elem(s(I,D,S,E),initial) :- I>=1,D=:=0,S=:=0,E=:=0.
elem(s(I,D,S,E),unsafe1) :- I>=0, D>=2, S>=0, E>=0.
elem(s(I,D,S,E),unsafe2) :- I>=0, D>=1, S>=1, E>=0.


%Temporal Properties

safe1 :- prop(not(ef(unsafe1))).
safe2 :- prop(not(ef(unsafe2))).
