%% Transitions

ts(X,[Y]) :- Y>=0.

t(X,Y) :- ts(X,Ys), mem(Y,Ys).

/*
t(X,Y) :- X=:=1, Y=:=2.
t(X,Y) :- X=:=1, Y=:=3.
t(X,Y) :- X=:=2, Y=:=5.
t(X,Y) :- X=:=3, Y=:=1.
t(X,Y) :- X=:=3, Y=:=6.
t(X,Y) :- X=:=4, Y=:=1.
t(X,Y) :- X=:=4, Y=:=3.
t(X,Y) :- X=:=4, Y=:=4.
t(X,Y) :- X=:=5, Y=:=2.
t(X,Y) :- X=:=5, Y=:=3.
t(X,Y) :- X=:=6, Y=:=7.
t(X,Y) :- X=:=7, Y=:=4.
*/

% Properties

p :- X=:=0, sat(X,af(1)).

elem(X,true).
elem(X,1) :- X>=1.

sat(S,E) :- elem(S,E).

sat(X, or(F1,F2)) :- sat(X, F1).
sat(X, or(F1,F2)) :- sat(X, F2).

sat(X, and(F1, F2)) :-  sat(X, F1), sat(X, F2).
%sat(X, and(F1, F2)) :-  \+ sat(X, or(not(F1),not(F2))).

sat(X, not(F)) :- \+ sat(X, F).

sat(X, imp(F1,F2)) :- \+ sat(X, F1).
sat(X, imp(F1,F2)) :- sat(X, F2).


% CTL operators

sat(S1, ex(F)) :- t(S1,S2), sat(S2, F).

sat(S, ef(F)) :- sat(S,F).
sat(S1, ef(F)) :- t(S1,S2), sat(S2,ef(F)).

sat(S, eu(_,F2)) :- sat(S, F2).
sat(S1, eu(F1,F2)) :- sat(S1,F1), t(S1,S2), sat(S2,eu(F1,F2)).

sat(S, eg(F)) :-  sat(S,not(af(not(F)))).

sat(S, er(F1,F2)) :-  sat(S,not(au(not(F1),not(F2)))).


sat(S, ax(F)) :- ts(S,Ss), sat_all(Ss, F).

sat(S, af(F)) :- sat(S,F).
sat(S, af(F)) :- ts(S,Ss), sat_all(Ss, af(F)).

sat(S, au(_,F2)) :- sat(S, F2).
sat(S1, au(F1,F2)) :- sat(S1,F1), ts(S1,Ss), sat_all(Ss,au(F1,F2)).

sat(S, ag(F)) :-  sat(S,not(ef(not(F)))).

sat(S, ar(F1,F2)) :-  sat(S,not(eu(not(F1),not(F2)))).


%%%%% Auxiliary

sat_all([], _).
sat_all([S|Ss], F) :- sat(S,F), sat_all(Ss, F).

mem(X,[X|Ys]).
mem(X,[Y|Ys]) :- mem(X,Ys).
