% taken from Delzanno CAV2000

%sat(s(I,D,E,SC,SD),el_unsafe1) :- D>=3.
%sat(s(I,D,E,SC,SD),el_unsafe2) :- D>=2, SC>=2.
%sat(s(I,D,E,SC,SD),el_unsafe3) :- D>=2, SD>=2.


sat(s(I,D,E,SC,SD), not(P)) :- \+ sat(s(I,D,E,SC,SD), P).

sat(s(I,D,E,SC,SD),ef(el_unsafe1)) :- D>=3.

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	I>=0,D>=0,SC>=0,SD>=0,E>=0,
	D+SC+SD+E>=1,
	sat(s(I,D,E,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,
	I1=:=I-1,E1=:=E+1,
	sat(s(I1,D,E1,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	I>=1,D>=1,E>=0,SC>=0,SD>=0,
	I1=:=I-1,D1=:=D-1,SD1=:=SD+1,SC1=:=SC+1,
	sat(s(I1,D1,E,SC1,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	I>=1,D=:=0,SC>=0,E>=0,SD>=0, SC+E+SD>=1,
	I1=:=I-1,SC1=:=SC+SD+E+1,E1=:=0,SD1=:=0,
	sat(s(I1,D,E1,SC1,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	D>=1,I>=0,E>=0,SC>=0,SD>=0,
	sat(s(I,D,E,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	E>=1,I>=0,SC>=0,SD>=0,D>=0,
	D1=:=D+1,E1=:=E-1,
	sat(s(I,D1,E1,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	E>=0,I>=0,D>=0,SD=:=1,SC=:=0,
	SD1=:=SD-1,D1=:=D+1,
	sat(s(I,D1,E,SC,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	E>=0,I>=0,D>=0,SC=:=1,SD=:=0,
	SC1=:=SC-1,D1=:=D+1,
	sat(s(I,D1,E,SC1,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	E>=0,I>=0,D>=0,SC+SD>=2,SC>=0,SD>=0,
	SC1=:=SC+SD-1,SD1=:=1,
	sat(s(I,D,E,SC1,SD1),ef(P)).


sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	I>=1,D=:=0,E=:=0,SC=:=0,SD=:=0,
	I1=:=I-1,D1=:=D+1,
	sat(s(I1,D1,E,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	I>=1,D>=1,E>=0,SC>=0,SD>=0,
	I1=:=I-1,D1=:=D-1,SD1=:=SD+1,SC1=:=SC+1,
	sat(s(I1,D1,E,SC1,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	I>=1,D=:=0,SC+E+SD>=1,SC>=0,E>=0,SD>=0,
	I1=:=I-1,SC1=:=SC+SD+E,E1=:=0,SD1=:=1,
	sat(s(I1,D,E1,SC1,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	D>=1, I>=0,SC>=0,SD>=0,E>=0,
	I1=:=I+1,D1=:=D-1,
	sat(s(I1,D1,E,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	SC>=1, I>=0,D>=0,SD>=0,E>=0,
	I1=:=I+1,SC1=:=SC-1,
	sat(s(I1,D,E,SC1,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	SD>=1, I>=0,SC>=0,D>=0,E>=0,
	I1=:=I+1,SD1=:=SD-1,
	sat(s(I1,D,E,SC,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D=<2,
	E>=1, I>=0,SC>=0,SD>=0,D>=0,
	I1=:=I+1,E1=:=E-1,
	sat(s(I1,D,E1,SC,SD),ef(P)).


safe1 :- I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,sat(s(I,D,E,SC,SD),not(ef(el_unsafe1))).
unsafe1 :- I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,sat(s(I,D,E,SC,SD),ef(el_unsafe1)).

safe2 :- I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,sat(s(I,D,E,SC,SD),not(ef(el_unsafe2))).
unsafe2 :- I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,sat(s(I,D,E,SC,SD),ef(el_unsafe2)).

safe3 :- I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,sat(s(I,D,E,SC,SD),not(ef(el_unsafe3))).
unsafe3 :- I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,sat(s(I,D,E,SC,SD),ef(el_unsafe3)).

