%Transitions

t(s(I,D,E,SC,SD),s(I,D,E,SC,SD)) :-
	I>=0,D>=0,SC>=0,SD>=0,E>=0,
	D+SC+SD+E>=1.

t(s(I,D,E,SC,SD),s(I1,D,E1,SC,SD)) :-
	I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,
	I1=:=I-1,E1=:=E+1.

t(s(I,D,E,SC,SD),s(I1,D1,E,SC1,SD1)) :-
	I>=1,D>=1,E>=0,SC>=0,SD>=0,
	I1=:=I-1,D1=:=D-1,SD1=:=SD+1,SC1=:=SC+1.

t(s(I,D,E,SC,SD),s(I1,D,E1,SC1,SD1)) :-
	I>=1,D=:=0,SC>=0,E>=0,SD>=0, SC+E+SD>=1,
	I1=:=I-1,SC1=:=SC+SD+E+1,E1=:=0,SD1=:=0.

t(s(I,D,E,SC,SD),s(I,D,E,SC,SD)) :-
	D>=1,I>=0,E>=0,SC>=0,SD>=0.

t(s(I,D,E,SC,SD),s(I,D1,E1,SC,SD)) :-
	E>=1,I>=0,SC>=0,SD>=0,D>=0,
	D1=:=D+1,E1=:=E-1.

t(s(I,D,E,SC,SD),s(I,D1,E,SC,SD1)) :-
	E>=0,I>=0,D>=0,SD=:=1,SC=:=0,
	SD1=:=SD-1,D1=:=D+1.

t(s(I,D,E,SC,SD),s(I,D1,E,SC1,SD)) :-
	E>=0,I>=0,D>=0,SC=:=1,SD=:=0,
	SC1=:=SC-1,D1=:=D+1.

t(s(I,D,E,SC,SD),s(I,D,E,SC1,SD1)) :-
	E>=0,I>=0,D>=0,SC+SD>=2,SC>=0,SD>=0,
	SC1=:=SC+SD-1,SD1=:=1.

t(s(I,D,E,SC,SD),s(I1,D1,E,SC,SD)) :-
	I>=1,D=:=0,E=:=0,SC=:=0,SD=:=0,
	I1=:=I-1,D1=:=D+1.

t(s(I,D,E,SC,SD),s(I1,D1,E,SC1,SD1)) :-
	I>=1,D>=1,E>=0,SC>=0,SD>=0,
	I1=:=I-1,D1=:=D-1,SD1=:=SD+1,SC1=:=SC+1.

t(s(I,D,E,SC,SD),s(I1,D,E1,SC1,SD1)) :-
	I>=1,D=:=0,SC+E+SD>=1,SC>=0,E>=0,SD>=0,
	I1=:=I-1,SC1=:=SC+SD+E,E1=:=0,SD1=:=1.

t(s(I,D,E,SC,SD),s(I1,D1,E,SC,SD)) :-
	D>=1, I>=0,SC>=0,SD>=0,E>=0,
	I1=:=I+1,D1=:=D-1.

t(s(I,D,E,SC,SD),s(I1,D,E,SC1,SD)) :-
	SC>=1, I>=0,D>=0,SD>=0,E>=0,
	I1=:=I+1,SC1=:=SC-1.

t(s(I,D,E,SC,SD),s(I1,D,E,SC,SD1)) :-
	SD>=1, I>=0,SC>=0,D>=0,E>=0,
	I1=:=I+1,SD1=:=SD-1.

t(s(I,D,E,SC,SD),s(I1,D,E1,SC,SD)) :-
	E>=1, I>=0,SC>=0,SD>=0,D>=0,
	I1=:=I+1,E1=:=E-1.


%Elementary Properties

elem(s(I,D,E,SC,SD),initial) :- I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0.
elem(s(I,D,E,SC,SD),unsafe1) :- D>=2.
elem(s(I,D,E,SC,SD),unsafe2) :- D>=1, SC>=1.
elem(s(I,D,E,SC,SD),unsafe3) :- D>=1, SD>=1.


%Temporal Properties

safe :- prop(not(or(ef(unsafe1),or(unsafe2,unsafe3)))).
safe1 :- prop(not(ef(unsafe1))).
safe2 :- prop(not(ef(unsafe2))).
safe3 :- prop(not(ef(unsafe3))).

