% Transitions

t(s(I,S,E,O,M),s(I,S,E,O,M)) :-
	I>=0,S>=0,M>=0,E>=0,
	S+M+E+O>=1.

t(s(I,S,E,O,M),s(I1,S1,E1,O1,M1)) :-
   	I>=1, S>=0,E>=0,M>=0,O>=0,
    	I1=:=I-1,
    	S1=:=S+E+1,
    	O1=:=O+M,
    	E1=:=0,
    	M1=:=0.

t(s(I,S,E,O,M),s(I,S,E,O,M)) :-
	M>=1,I>=0,E>=0,S>=0,O>=0.

t(s(I,S,E,O,M),s(I,S,E1,O,M1)) :-
	I>=0,S>=0,M>=0,E>=1,
        E1=:=E-1,M1=:=M+1.

t(s(I,S,E,O,M),s(I1,S1,E1,O1,M1)) :-
	I>=0,S+O>=1,S>=0,O>=0,M>=0,E>=0,
        I1=:=I+O+M+E+S-1,E1=:=1,M1=:=0,O1=:=0,S1=:=0.

t(s(I,S,E,O,M),s(I1,S1,E1,O,M1)) :-
	I>=1, S>=0,E>=0,M>=0,O>=0,
        I1=:=I+O+S+E+M-1,S1=:=0,E1=:=1,M1=:=0,O1=:=0.

t(s(I,S,E,O,M),s(I1,S,E1,O,M)) :-
	I>=0,S>=0,M>=0,E>=1,O>=0,
        E1=:=E-1,I1=:=I+1.

t(s(I,S,E,O,M),s(I1,S1,E,O,M)) :-
	I>=0,S>=1,M>=0,E>=0,O>=0,
        S1=:=S-1,I1=:=I+1.

t(s(I,S,E,O,M),s(I1,S,E,O,M1)) :-
	I>=0,S>=0,M>=1,O>=0,E>=0,
        M1=:=M-1,I1=:=I+1.

t(s(I,S,E,O,M),s(I1,S,E,O1,M)) :-
	I>=0,S>=0,M>=0,E>=0,O>=1,
        O1=:=O-1,I1=:=I+1.


%Elementary Properties

elem(s(I,S,E,O,M),initial) :- I>=0,S=:=0,E=:=0,M=:=0,O1=:=0.
elem(s(I,S,E,O,M),unsafe1) :- S>=1, M>=1.
elem(s(I,S,E,O,M),unsafe2) :- E>=2.


% Temporal Properties

safe1 :- prop(not(ef(unsafe1))).
safe2 :- prop(not(ef(unsafe2))).
