%% Transitions

t(X,Y) :- X=:=1, Y=:=2.
t(X,Y) :- X=:=1, Y=:=3.
t(X,Y) :- X=:=2, Y=:=5.
t(X,Y) :- X=:=3, Y=:=1.
t(X,Y) :- X=:=3, Y=:=6.
t(X,Y) :- X=:=4, Y=:=1.
t(X,Y) :- X=:=4, Y=:=3.
t(X,Y) :- X=:=4, Y=:=4.
t(X,Y) :- X=:=5, Y=:=2.
t(X,Y) :- X=:=5, Y=:=3.
t(X,Y) :- X=:=6, Y=:=7.
t(X,Y) :- X=:=7, Y=:=4.


ts(X,[Y1,Y2]) :- X=:=1, Y1=:=2, Y2=:=3.
ts(X,[Y]) :- X=:=2, Y=:=5.
ts(X,[Y1,Y2]) :- X=:=3, Y1=:=1, Y2=:=6.
ts(X,[Y1,Y2,Y3]) :- X=:=4, Y1=:=1, Y2=:=3, Y3=:=4.
ts(X,[Y1,Y2]) :- X=:=5, Y1=:=2, Y2=:=3.
ts(X,[Y]) :- X=:=6, Y=:=7.
ts(X,[Y]) :- X=:=7, Y=:=4.


% Elementary Properties

elem(X,true).
elem(X,start) :- X=:=2.
elem(X,error) :- X=:=2.
elem(X,close) :- X=:=3.
elem(X,close) :- X=:=4.
elem(X,heat) :- X=:=4.
elem(X,start) :- X=:=5.
elem(X,close) :- X=:=5.
elem(X,error) :- X=:=5.
elem(X,start) :- X=:=6.
elem(X,close) :- X=:=6.
elem(X,start) :- X=:=7.
elem(X,close) :- X=:=7.
elem(X,heat) :- X=:=7.


% Temporal Properties

p01 :- X=:=1, sat(X,eg(not(start))). %true 130ms -> 80ms
p02 :- X=:=1, sat(X,er(heat,not(error))). %true 160ms -> 110ms
p03 :- X=:=1, sat(X,au(not(heat),error)). %false 70ms -> 100ms
p1 :- X=:=1, sat(X,ag(imp(start,af(heat)))). %false 290ms -> 160ms

p4 :- X=:=1, sat(X,ef(and(not(close),and(start,and(ef(heat),eg(error)))))). %true 470ms -> 280ms
p5 :- X=:=1, sat(X,ef(and(close,and(start,and(ef(heat),eg(error)))))). %true 440ms -> 300ms
p6 :- X=:=1, sat(X,ag(or(not(start),error))). %false 190ms -> 90ms
p7 :- X=:=1, sat(X,ag(or(not(start),not(close)))). %false 230ms -> 140ms
p8 :- X=:=1, sat(X,not(eu(true,and(not(close),and(start,and(ef(heat),eg(error))))))). %false 470ms -> 240ms
p9 :- X=:=1, sat(X,not(eu(ef(and(not(close),and(start,and(start,and(ef(heat),eg(error)))))),
	and(not(close),and(start,or(ef(heat),eg(error))))))). % false 780ms -> 390ms
p10 :- X=:=1, sat(X,au(ef(and(not(close),and(start,and(ef(heat),eg(error))))),
	ag(or(not(start),error)))). %false 930ms -> 430ms
p11 :- X=:=1, sat(X,au(ef(and(not(close),and(start,and(ef(heat),eg(error))))),
	not(ef(and(not(close),and(start,and(ef(heat),eg(error)))))))). %false 730 -> 290ms
p12 :- X=:=1, sat(X,eu(ag(imp(start,af(heat))),not(ef(ex(and(error,ag(imp(start,af(heat))))))))).
%true 740ms -> 360ms
p13 :- X=:=1, sat(X,eu(ag(imp(start,af(eu(ag(imp(start,af(heat))),
not(ef(ex(and(error,ag(imp(start,af(eu(ag(imp(start,af(heat))),
not(ef(ex(and(error,ag(imp(start,af(heat))))))))))))))))))),
not(ef(ex(and(error,ag(imp(start,af(eu(ag(imp(start,af(heat))),
not(ef(ex(and(error,ag(imp(start,af(heat))))))))))))))))).
%false 2950ms
%2810 ts,mem -> t
%2630 no simplify, hashing of defs
%2350 subsume cfacts only, no remove_f
%2290 cut, no findall
%2030 eq_prog -> no transf applied
%1200 memo decided (cfacts/false) preds
