%% Transitions


t(1,2).
t(1,3).
t(2,5).
t(3,1).
t(3,6).
t(4,1).
t(4,3).
t(4,4).
t(5,2).
t(5,3).
t(6,7).
t(7,4).


/*
t(X,Y) :- X=:=1, Y=:=2.
t(X,Y) :- X=:=1, Y=:=3.
t(X,Y) :- X=:=2, Y=:=5.
t(X,Y) :- X=:=3, Y=:=1.
t(X,Y) :- X=:=3, Y=:=6.
t(X,Y) :- X=:=4, Y=:=1.
t(X,Y) :- X=:=4, Y=:=3.
t(X,Y) :- X=:=4, Y=:=4.
t(X,Y) :- X=:=5, Y=:=2.
t(X,Y) :- X=:=5, Y=:=3.
t(X,Y) :- X=:=6, Y=:=7.
t(X,Y) :- X=:=7, Y=:=4.
*/

% Properties

p01 :- sats(1,e(g(not(start)))). %true /failed
p02 :- sats(1,e(not(u(not(heat),error)))). %true /failed
p03 :- sats(1,a(u(not(heat),error))). %false /failed
p1 :- sats(1,a(g(imp(start,a(f(heat)))))). %ctl true /failed
p2 :- sats(1,a(u(not(heat),close))). %ltl true /failed
p3 :- sats(1,not(e(f(and(not(close),and(start,e(and(f(heat),g(error))))))))). %ctl* true /failed

p4 :- sats(1,e(f(and(not(close),and(start,e(and(f(heat),g(error)))))))). %failed
p5 :- sats(1,e(f(and(close,and(start,e(and(f(heat),g(error)))))))). %failed
p6 :- sats(1,a(g(or(not(start),error)))). %failed
p7 :- sats(1,a(g(or(not(start),not(close))))). %failed
p8 :- sats(1,not(e(u(true,and(not(close),and(start,e(and(f(heat),g(error))))))))). %failed
p9 :- sats(1,not(e(u(e(f(and(not(close),and(start,e(and(f(heat),g(error))))))),
	and(not(close),and(start,e(and(f(heat),g(error))))))))). % failed
p10 :- sats(1,a(u(e(f(and(not(close),and(start,e(and(f(heat),g(error))))))),
	a(g(or(not(start),error)))))). %false
p11 :- sats(1,a(u(e(f(and(not(close),and(start,e(and(f(heat),g(error))))))),
	not(e(f(and(not(close),and(start,e(and(f(heat),g(error))))))))))). %failed
p12 :- sats(1,e(u(a(g(imp(start,a(f(heat))))),not(e(f(e(x(and(error,a(g(imp(start,a(f(heat)))))))))))))).
%false
p13 :- sats(1,e(u(a(g(imp(start,a(f(e(u(a(g(imp(start,a(f(heat))))),
not(e(f(e(x(and(error,a(g(imp(start,a(f(e(u(a(g(imp(start,a(f(heat))))),
not(e(f(e(x(and(error,a(g(imp(start,a(f(heat))))))))))))))))))))))))))))))),
not(e(f(e(x(and(error,a(g(imp(start,a(f(e(u(a(g(imp(start,a(f(heat))))),
not(e(f(e(x(and(error,a(g(imp(start,a(f(heat))))))))))))))))))))))))))).
%true

elem(S,true).
elem(2,start).
elem(2,error).
elem(3,close).
elem(4,close).
elem(4,heat).
elem(5,start).
elem(5,close).
elem(5,error).
elem(6,start).
elem(6,close).
elem(7,start).
elem(7,close).
elem(7,heat).

sats(S,E) :- elem(S,E).

sats(X, or(F1,F2)) :- sats(X, F1).
sats(X, or(F1,F2)) :- sats(X, F2).

%sats(X, and(F1, F2)) :-  sats(X, F1), sats(X, F2).
sats(X, and(F1, F2)) :-  \+ sats(X, or(not(F1),not(F2))).

sats(X, not(F)) :- \+ sats(X, F).

sats(X, imp(F1,F2)) :- \+ sats(X, F1).
sats(X, imp(F1,F2)) :- sats(X, F2).

sats(S, e(F)) :- satp([S|P],F).


%%% path formulas

satp([S|P],F) :- elem(S,F).
satp([S|P],e(F)) :- sats(S,e(F)).

satp(X, or(F1,F2)) :- satp(X, F1).
satp(X, or(F1,F2)) :- satp(X, F2).

%satp(X, and(F1, F2)) :-  satp(X, F1), satp(X, F2).
satp(X, and(F1, F2)) :-  \+ satp(X, or(not(F1),not(F2))).

satp(X, not(F)) :- \+ satp(X, F).

satp(X, imp(F1,F2)) :- \+ satp(X, F1).
satp(X, imp(F1,F2)) :- satp(X, F2).

satp([S1,S2|P], x(F)) :- t(S1,S2), satp([S2|P],F).

satp(P, u(F1,F2)) :- satp(P,F2).
satp([S1,S2|P], u(F1,F2)) :- t(S1,S2), satp([S1,S2|P],F1), satp([S2|P],u(F1,F2)).

%satp([S1,S2|P], u(F1,F2)) :- t(S1,S2), satp([S1,S2|P],and(F1,x(u(F1,F2)))). %NOT LOCALLY STRATIFIED

%satp([S1,S2|P], u(F1,F2)) :- t(S1,S2), \+ o(S1,S2,P,F1,F2).
%o(S1,S2,P,F1,F2) :- \+ satp([S1,S2|P],F1).
%o(S1,S2,P,F1,F2) :- \+ satp([S2|P],u(F1,F2)). %NOT LOCALLY STRATIFIED


% Derived CTL* operators

sats(P,a(F)) :- \+ sats(P,e(not(F))).

satp(P, f(F)) :- satp(P,F).
satp([S1,S2|P], f(F)) :- t(S1,S2), satp([S2|P], f(F)).

satp(P, g(F)) :- \+ satp(P, f(not(F))).

satp(P, r(F1,F2)) :- \+ satp(P, u(not(F1),not(F2))).
