% Reset Petri Net

%Transitions

t(s(X,Y,[a1|T]),s(X1,Y1,T)) :- X>=1, X1=:=0, Y1=:=Y+2.
t(s(X,Y,[a2|T]),s(X1,Y1,T)) :- Y>=1, X1=:=X+2, Y1=:=Y-1.

%t(s(X,Y,T),s(X1,Y1,[a1|T])) :- X>=1, X1=:=0, Y1=:=Y+2.
%t(s(X,Y,T),s(X1,Y1,[a2|T])) :- Y>=1, X1=:=X+2, Y1=:=Y-1.

ts(s(X,Y,[[a1,T1]]),[s(X1,Y1,T1)]):- X>=1, Y=:=0, X1=:=0, Y1=:=Y+2.
ts(s(X,Y,[[a2,T1]]),[s(X1,Y1,T1)]):- X=:=0, Y>=1, X1=:=X+2, Y1=:=Y-1.
ts(s(X,Y,[[a1,T1],[a2,T2]]),[s(X1,Y1,T1),s(X2,Y2,T2)]):- X>=1, Y>=1, 
			X1=:=0, Y1=:=Y+2, 
			X2=:=X+2, Y2=:=Y-1.



%Elementary Properties

elem(s(X,Y,_),initial) :- X=:=1, Y=:=0.
%elem(s(X,Y,_),p30) :- X=:=3, Y=:=0.
%elem(s(X,Y,_),p4) :- X>=4.
%elem(s(X,Y,_),p2) :- X>=2.
%elem(s(X,Y,_),q2) :- X>=1.
%elem(s(X,Y,_),q2) :- Y>=1.
elem(s(X,Y,_),notq2) :- X=:=0,Y=:=0.

%elem(s(X,Y,_),q) :- X>2.

%elem(s(X,Y,_),p2) :- Y=<2.

%elem(s(X,Y,_),p) :- X>=1,Y>=1.
%elem(s(X,Y,_),notq) :- X=<2.


%elem(s(X,Y),initial21) :- X=:=2, Y>=1.
%elem(s(X,Y),initial10) :- X=:=1, Y=:=0.
%elem(s(X,Y),p0) :- X=:=0, Y=:=0.
%elem(s(X,Y),p1) :- X=:=3, Y=:=1.
%elem(s(X,Y),p2) :- X=:=3, Y=:=0.
%elem(s(X,Y),p3) :- X=:=3.

%Temporal Properties

safe :- prop(not(ef(p30))).
%reach31 :- prop(ef(p31)).
reach4 :- prop(ef(p4)).

reach :- prop(ef(p)).

witness1 :- sat(s(X,Y,L),and(initial,ef(p))).

witness1(L) :- sat(s(X,Y,L),and(initial,ef(p))).
witness2(L) :- sat(s(X,Y,L),and(initial,af(p2))).
witness3(L) :- sat(s(X,Y,L),and(initial,eg(p3))).

witness4(L) :- sat(s(X,Y,L),and(initial,af(q))).
witness5(L) :- sat(s(X,Y,L),and(initial,eg(notq))).
witness6(L) :- sat(s(X,Y,L),and(initial,eg(q2))).
witness7(L) :- sat(s(X,Y,L),and(initial,af(notq2))).

%prop0 :- exists_state(and(initial10,not(ef(p0)))).
%prop1 :- \+ exists_state(and(initial21,not(ef(p1)))).
%prop1neg :- \+ exists_state(and(initial21,ef(p1))).
%prop2 :- \+ exists_state(and(initial21,ef(p2))).
%prop3 :- \+ exists_state(and(initial21,ef(p3))).