% state vs s

%%------------------------------------------------
%% D-Robot pag.270

% Transitions

%ts(s(S0,X0),[s(S1,X1)]) :- t(s(S0,X0),s(S1,X1)).

t(s(d_wait,X),s(d_pick,0)).
t(s(d_pick,X),s(d_turn_R,0)) :- D>=0, XN=:=X+D, XN=<2, XN>=1.
t(s(d_turn_R,X),s(d_put,0)) :- D>=0, XN=:=X+D, XN=<6, XN>=5.
t(s(d_put,X),s(d_turn_L,0)) :- D>=0, XN=:=X+D, XN=<2, XN>=1.
t(s(d_turn_L,X),s(d_wait,0)) :- D>=0, XN=:=X+D, XN=<6, XN>=5.

elem(s(d_wait,X),safe).
elem(s(d_pick,X),safe):- X=<2.
elem(s(d_turn_R,X),safe):- X=<6.
elem(s(d_put,X),safe):- X=<2.
elem(s(d_turn_L,X),safe):- X=<6.

%%------------------------------------------------
%% G-Robot pag.271

% Transitions

%ts(s(S1,Y),[s(S2,YN)]):- t(s(S1,Y),s(S2,YN)).

t(s(g_inspect,_), s(g_pick,0)).
t(s(g_pick,Y), s(g_turn_R,0)):- D>=0, YN=:=Y+D, YN=<8, YN>=3.
t(s(g_turn_R,Y), s(g_wait,0)):- D>=0, YN=:=Y+D, YN=<10, YN>=6.
t(s(g_wait,_), s(g_put,0)).
t(s(g_put,Y), s(g_turn_L,0)):- D>=0, YN=:=Y+D, YN=<2, YN>=1.
t(s(g_turn_L,Y), s(g_inspect,0)):- D>=0, YN=:=Y+D, YN=<10, YN>=8.

elem(s(g_inspect,_),safe).
elem(s(g_pick,Y),safe):- Y=<8.
elem(s(g_turn_R,Y),safe):- Y=<10.
elem(s(g_wait,_),safe).
elem(s(g_put,Y),safe):- Y=<2.
elem(s(g_turn_L,Y),safe):- Y=<10.

%%------------------------------------------------
%% S-Robot (processing station) pag.272

%% Transitions

%ts(s(S0,Z0),[s(S1,Z1)]) :- t(s(S0,Z0),s(S1,Z1)).

t(s(s_empty,Z),s(s_busy,0)).
t(s(s_empty,Z),s(s_empty,Z)).
t(s(s_busy,Z),s(s_ready,0)) :- D>=0, ZN=:=Z+D, ZN=<10, ZN>=8.
t(s(s_ready,Z),s(s_empty,0)).
t(s(s_ready,Z),s(s_ready,Z)).

elem(s(s_empty,Z),safe).
elem(s(s_busy,Z),safe):- Z=<10.
elem(s(s_ready,Z),safe).


%%------------------------------------------------
%% B-Robot (box) pag.273

% Transitions

%ts(s(S1,B),[s(S2,BN)]):- t(s(S1,B),s(S2,BN)).

t(s(b_move,B), s(b_inspect,0)):- D>=0, BN=:=B+D, BN=<134, BN>=133.
t(s(b_inspect,B), s(b_inspect,BN)):- D>=0, BN=:=B+D, BN=<21.
t(s(b_inspect,B), s(b_fall,BN)):- D>=0, BN=:=B+D, BN=<21, BN>=20.
t(s(b_inspect,B), s(b_on_G,BN)):- D>=0, BN=:=B+D, BN=<21.
t(s(b_on_G,B), s(b_on_S,BN)):- D>=0, BN=:=B+D.
t(s(b_on_S,B), s(b_on_D,BN)):- D>=0, BN=:=B+D.
t(s(b_on_D,_), s(b_move,0)).

elem(s(b_move,B),safe):- B=<134.
elem(s(b_inspect,B),safe):- B=<21.
elem(s(b_fall,_),safe).
elem(s(b_on_G,_),safe).
elem(s(b_on_S,_),safe).
elem(s(b_on_D,_),safe).

%%-----------------------------------------------
%% Modello del Sistema - Robot in parallelo
%%-----------------------------------------------

% Transitions

ts(state(D,G,S,B),[state(ND,G,S,B),state(D,NG,S,B),state(D,G,NS,B),state(D,G,S,NB)]):-
	t(state(D,G,S,B),state(ND,G,S,B)), t(state(D,G,S,B),state(D,NG,S,B)), t(state(D,G,S,B), state(D,G,NS,B)), t(state(D,G,S,B),state(D,G,S,NB)).

t(state(s(N1,C1),s(N2,C2),s(N3,C3),s(N4,C4)),state(s(NN1,NC1),s(N2,C2),s(N3,C3),s(N4,C4))):-
	t(s(N1,C1),s(NN1,NC1)), ((N1=d_wait, N3=s_ready) ; N1=d_pick; N1=d_turn_R; N1=d_put; N1=d_turn_L).
t(state(s(N1,C1),s(N2,C2),s(N3,C3),s(N4,C4)),state(s(N1,C1),s(NN2,NC2),s(N3,C3),s(N4,C4))):-
	t(s(N2,C2),s(NN2,NC2)), ((N2=g_wait, N3=s_empty) ; N2=g_inspect; N2=g_pick; N2=g_turn_R; N2=g_turn_L; N2=g_put).
t(state(s(N1,C1),s(N2,C2),s(N3,C3),s(N4,C4)),state(s(N1,C1),s(N2,C2),s(NN3,NC3),s(N4,C4))):-
	t(s(N3,C3),s(NN3,NC3)), ((N3=s_empty, N2=g_put, NN3=s_busy); (N3=s_empty, NN3=s_empty); (N3=s_ready, N1=d_pick, NN3=s_empty); (N3=s_ready, NN3=s_ready); N3=s_busy).
t(state(s(N1,C1),s(N2,C2),s(N3,C3),s(N4,C4)),state(s(N1,C1),s(N2,C2),s(N3,C3),s(NN4,NC4))):-
	t(s(N4,C4),s(NN4,NC4)), (N4=b_move; (N4=b_inspect, NN4=b_fall); (N4=b_inspect, NN4=b_inspect); (N4=b_inspect, N2=g_pick, NN4=b_on_G); (N4=b_on_G, N2=g_put); (N4=b_on_S, N1=d_pick); (N4=b_on_D, N1=d_put)).

elem(state(D,G,S,B),safe):- elem(D,safe), elem(G,safe), elem(S,safe), elem(B,safe).

%% Properties
p01:- sat(state(s(d_wait,0),s(g_inspect,0),s(s_empty,0),s(b_move,0)), ef(safe)). %true
p02:- sat(state(s(d_wait,0),s(g_inspect,0),s(s_empty,0),s(b_move,0)), af(safe)). %true
p03:- sat(state(s(d_wait,0),s(g_inspect,0),s(s_empty,0),s(b_move,0)), ag(safe)). %true 
