%Transitions

%t(s(a,X,[t1|T]), s(a,Y,T)) :- Y=:=X+2.
%t(s(a,X,[t2|T]), s(b,X,T)) :- X>0.
%t(s(b,X,[t3|T]), s(b,Y,T)) :- Y=:=X+1.

%ts(s(a,X,[[t1,T1]]),[s(a,Y,T1)]) :-  X=<0, Y=:=X+2.
%ts(s(a,X,[[t1,T1],[t2,T2]]),[s(a,Y,T1),s(b,X,T2)]) :-  X>0, Y=:=X+2.
%ts(s(b,X,[[t3,T]]),[s(b,Y,T)]) :- Y=:=X+1.

t(s(a,X),t1, s(a,Y)) :- Y=:=X+2.
t(s(a,X),t2, s(b,X)) :- X>0.
t(s(b,X),t3, s(b,Y)) :- Y=:=X+1.

ts(s(a,X),[(t1,s(a,Y))]) :-  X=<0, Y=:=X+2.
ts(s(a,X),[(t1,s(a,Y)),(t2,s(b,X))]) :-  X>0, Y=:=X+2.
ts(s(b,X),[(t3,s(b,Y))]) :- Y=:=X+1.

%Elementary Properties

elem(s(a,X),initial) :- X=:=0.
elem(s(_,X),neg) :- X<0.
elem(s(_,X),pos) :- X>0.
elem(s(_,X),geq4) :- X>=4.
elem(s(a,_),isa).
elem(s(b,_),isb).


%Temporal Properties

vclprop :- \+ negprop.
negprop :- sat(s(C,X,_),and(initial,af(neg))).
%weu(W) :- witness(eu(isa,and(isb,geq4)),W).
%waf(W) :- witness(af(neg),W).
weu(W) :- X=:=0, sat_w(s(a,X),eu(isa,and(isb,geq4)),W).
waf(W) :- X=:=0, sat_w(s(a,X),af(neg),W).
