%% Transitions

ts(X,[Y1,Y2]) :- X>0, X=<1, Y1=:=X+1, Y2=:=X+2.
ts(X,[Y]) :- X>1, X=<2, Y=:=X+3.
ts(X,[Y1,Y2]) :- X>2, X=<3, Y1=:=X-2, Y2=:=X+3.
ts(X,[Y1,Y2,Y3]) :- X>3, X=<4, Y1=:=X-3, Y2=:=X-1, Y3=:=X.
ts(X,[Y1,Y2]) :- X>4, X=<5, Y1=:=X-3, Y2=:=X-2.
ts(X,[Y]) :- X>5, X=<6, Y=:=X+1.
ts(X,[Y]) :- X>6, X=<7, Y=:=X-3.

t(X,Y) :- ts(X,Ys), mem(Y,Ys).

/*
t(X,Y) :- X=:=1, Y=:=2.
t(X,Y) :- X=:=1, Y=:=3.
t(X,Y) :- X=:=2, Y=:=5.
t(X,Y) :- X=:=3, Y=:=1.
t(X,Y) :- X=:=3, Y=:=6.
t(X,Y) :- X=:=4, Y=:=1.
t(X,Y) :- X=:=4, Y=:=3.
t(X,Y) :- X=:=4, Y=:=4.
t(X,Y) :- X=:=5, Y=:=2.
t(X,Y) :- X=:=5, Y=:=3.
t(X,Y) :- X=:=6, Y=:=7.
t(X,Y) :- X=:=7, Y=:=4.
*/

% Properties
not_p01 :- X>0, X=<1, sat(X,not(eg(not(start)))). %false 210ms

not_p02 :- X>0, X=<1, sat(X,not(er(heat,not(error)))). %false 240ms
not_p03 :- X>0, X=<1, sat(X,not(au(not(heat),error))). %true 180ms
not_p1 :- X>0, X=<1, sat(X,not(ag(imp(start,af(heat))))). %true 450ms

not_p4 :- X>0, X=<1, sat(X,not(ef(and(not(close),and(start,and(ef(heat),eg(error))))))). %false 590ms
not_p5 :- X>0, X=<1, sat(X,not(ef(and(close,and(start,and(ef(heat),eg(error))))))). %false 530ms
not_p6 :- X>0, X=<1, sat(X,not(ag(or(not(start),error)))). %true 290ms
not_p7 :- X>0, X=<1, sat(X,not(ag(or(not(start),not(close))))). %true 340ms
not_p8 :- X>0, X=<1, sat(X,eu(true,and(not(close),and(start,and(ef(heat),eg(error)))))). %true 590ms
not_p9 :- X>0, X=<1, sat(X,eu(ef(and(not(close),and(start,and(start,and(ef(heat),eg(error)))))),
	and(not(close),and(start,or(ef(heat),eg(error)))))). %true 870ms
not_p10 :- X>0, X=<1, sat(X,not(au(ef(and(not(close),and(start,and(ef(heat),eg(error))))),
	ag(or(not(start),error))))). %true 1040ms
not_p11 :- X>0, X=<1, sat(X,not(au(ef(and(not(close),and(start,and(ef(heat),eg(error))))),
	not(ef(and(not(close),and(start,and(ef(heat),eg(error))))))))). %true 800ms
not_p12 :- X>0, X=<1, sat(X,not(eu(ag(imp(start,af(heat))),not(ef(ex(and(error,ag(imp(start,af(heat)))))))))). %false 970ms
not_p13 :- X>0, X=<1, sat(X,not(eu(ag(imp(start,af(eu(ag(imp(start,af(heat))),
	not(ef(ex(and(error,ag(imp(start,af(eu(ag(imp(start,af(heat))),
	not(ef(ex(and(error,ag(imp(start,af(heat))))))))))))))))))),
	not(ef(ex(and(error,ag(imp(start,af(eu(ag(imp(start,af(heat))),
	not(ef(ex(and(error,ag(imp(start,af(heat)))))))))))))))))). %true 2580ms


elem(X,true).
elem(X,start) :- X>1, X=<2.
elem(X,error) :- X>1, X=<2.
elem(X,close) :- X>2, X=<3.
elem(X,close) :- X>3, X=<4.
elem(X,heat) :- X>3, X=<4.
elem(X,start) :- X>4, X=<5.
elem(X,close) :- X>4, X=<5.
elem(X,error) :- X>4, X=<5.
elem(X,start) :- X>5, X=<6.
elem(X,close) :- X>5, X=<6.
elem(X,start) :- X>6, X=<7.
elem(X,close) :- X>6, X=<7.
elem(X,heat) :- X>6, X=<7.

/*
elem(X,start) :- X=:=2.
elem(X,error) :- X=:=2.
elem(X,close) :- X=:=3.
elem(X,close) :- X=:=4.
elem(X,heat) :- X=:=4.
elem(X,start) :- X=:=5.
elem(X,close) :- X=:=5.
elem(X,error) :- X=:=5.
elem(X,start) :- X=:=6.
elem(X,close) :- X=:=6.
elem(X,start) :- X=:=7.
elem(X,close) :- X=:=7.
elem(X,heat) :- X=:=7.
*/

sat(S,E) :- elem(S,E).

sat(X, or(F1,F2)) :- sat(X, F1).
sat(X, or(F1,F2)) :- sat(X, F2).

sat(X, and(F1, F2)) :-  sat(X, F1), sat(X, F2).
%sat(X, and(F1, F2)) :-  \+ sat(X, or(not(F1),not(F2))).

sat(X, not(F)) :- \+ sat(X, F).

sat(X, imp(F1,F2)) :- \+ sat(X, F1).
sat(X, imp(F1,F2)) :- sat(X, F2).


% CTL operators

sat(S1, ex(F)) :- t(S1,S2), sat(S2, F).

sat(S, ef(F)) :- sat(S,F).
sat(S1, ef(F)) :- t(S1,S2), sat(S2,ef(F)).

sat(S, eu(_,F2)) :- sat(S, F2).
sat(S1, eu(F1,F2)) :- sat(S1,F1), t(S1,S2), sat(S2,eu(F1,F2)).

sat(S, eg(F)) :-  sat(S,not(af(not(F)))).

sat(S, er(F1,F2)) :-  sat(S,not(au(not(F1),not(F2)))).


sat(S, ax(F)) :- ts(S,Ss), sat_all(Ss, F).

sat(S, af(F)) :- sat(S,F).
sat(S, af(F)) :- ts(S,Ss), sat_all(Ss, af(F)).

sat(S, au(_,F2)) :- sat(S, F2).
sat(S1, au(F1,F2)) :- sat(S1,F1), ts(S1,Ss), sat_all(Ss,au(F1,F2)).

sat(S, ag(F)) :-  sat(S,not(ef(not(F)))).

sat(S, ar(F1,F2)) :-  sat(S,not(eu(not(F1),not(F2)))).


%%%%% Auxiliary

sat_all([], _).
sat_all([S|Ss], F) :- sat(S,F), sat_all(Ss, F).

mem(X,[X|Ys]).
mem(X,[Y|Ys]) :- mem(X,Ys).
