%m(P,Xs,S) :- S is the symbol at position P (starting from 1) of string Xs

m(first,[X|Xs],X).
m(next(P),[X|Xs],Y) :- m(P,Xs,Y).

% m(first,[a|Xs],a).
% m(first,[b|Xs],b).
% m(first,[c|Xs],c).
% m(next(P),[a|Xs],a) :- m(P,Xs,a).
% m(next(P),[a|Xs],b) :- m(P,Xs,b).
% m(next(P),[a|Xs],c) :- m(P,Xs,c).
% m(next(P),[b|Xs],a) :- m(P,Xs,a).
% m(next(P),[b|Xs],b) :- m(P,Xs,b).
% m(next(P),[b|Xs],c) :- m(P,Xs,c).
% m(next(P),[c|Xs],a) :- m(P,Xs,a).
% m(next(P),[c|Xs],b) :- m(P,Xs,b).
% m(next(P),[c|Xs],c) :- m(P,Xs,c).


less(first,next(X)).
less(next(X),next(Y)) :- less(X,Y).

%TYPE DEFINITIONS

symbol(a).
symbol(b).
symbol(c).

string([]).
% string([X|Xs]) :- symbol(X), string(Xs).
string([a|Xs]) :- string(Xs).
string([b|Xs]) :- string(Xs).
string([c|Xs]) :- string(Xs).

pos(first).
pos(next(X)) :- pos(X).


%TYPE DECLARATIONS

type(m,3,[pos,string,symbol]).

type(less,2,[pos,pos]).






