%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                         %
% last modified - 27/09/2002              %
% by Valerio Senni                        %
% - mwgc_q.pl -                           %
%                                         %
% query file for MWGC problem             %
% to be provided to MAP system for the    %
% derivation of the solution.             %
%                                         %
% prFIN. is the goal which synthesize     %
% the desired solution                    %
%                                         %
% - program refers to file mwgc_th.pl     %
%   containing theory necessary for       %
%   synthesis                             %
%                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
% Measurement performed on a PIII 550Mhz 384Mb RAM
%
% timings syntax: new-MAP w CUTS [newMAP with sebsumtion and restriction rules]
%

% PR.1
pr1 :- prove(e([E],(inEv(E) and finEv(E) and goodSeq(E)))). % CANNOT UNFOLD NEG LITERAL

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% PR.2 there exsts a sequence of transition from an initial to a final state

pr2 :- prove(e([E],(inEv(E) and finEv(E) and trSeq(E)))). % PROVED 3575ms(dtrace(off)) [1622ms]
pr2neg :- prove(\+ e([E],(inEv(E) and finEv(E) and trSeq(E)))). % PROVED 3556ms(dtrace(off)) [1663ms]

st2 :- synth((inEv(E) and finEv(E) and trSeq(E))). % SUCEEDED 4687ms(on-screen output) [1332ms]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% PR.3 there exists a states evolution which is Initial, Final,
% made out of Transitions and whose states are all good, no matter for the length

pr3 :- prove(e([E],(inEv(E) and finEv(E) and trSeq(E) and goodSeq(E)))). % PROVED 39638ms(dtrace(off)) [24234ms]
pr3neg :- prove(\+ e([E],(inEv(E) and finEv(E) and trSeq(E) and goodSeq(E)))). % DISPROVED 39696ms(dtrace(off)) [24325ms]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% PR.FINAL there exists a states evolution which is Initial, Final, of Length L,
% made out of Transitions and whose states are all good

prFINAL :- prove(e([E,L],(inEv(E) and finEv(E) and length(L,E) and trSeq(E) and goodSeq(E)))). % PROVED 76168ms(dtrace(off)) [41560ms]
prFINAL1 :- prove(e([E,L],(inEv(E) and trSeq(E) and goodSeq(E) and finEv(E)
and length(L,E)))).
% PROVED 76168ms(dtrace(off)) [41560ms]

prFINALneg :- prove(\+ e([E,L],(inEv(E) and finEv(E) and length(L,E) and
trSeq(E) and goodSeq(E)))). % DISPROVED 75217ms(dtrace(off)) [41471ms]

stFINAL :- synth((inEv(E) and finEv(E) and length(L,E) and trSeq(E) and goodSeq(E))). % SUCCEED 100585ms(on-screen output) 201838ms(on-file output(tell command)) [52235ms]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% from any initial state there exists a sequence of transition leading to the final state
pr4 :- prove(\+ e([I],\+ e([E],(stEvolution([I|E]) and finEv(E) and trSeq([I|E]))))). % OUT OF MEMORY
pr6 :- prove(a([I],e([E],(stEvolution([I|E]) and finEv(E) and trSeq([I|E]))))).

pr5 :- prove(e([L,E],(length(L,E) and inEv(E) and trSeq(E) and \+ finEv(E)))). % PROVED 4607ms [1462ms]

prFIN2 :- prove(a([L],((leq(s(s(s(s(s(s(s(0))))))),L) and odd(L)) -> e([E],(inEv(E) and finEv(E) and length(L,E) and trSeq(E) and goodSeq(E)))))). % []

