%%%%% load ws1s program first %%%%%%
% Timings on PentiumII 300Mhz

%%%%%% PROOF EXAMPLES %%%%%%%%%

prop0 :- prove(a([X],e([Y],leq(X,Y)))).

test :-
prove((a([S1],(e([X], m(X,S1)) -> e([S2],(\+ e([X], m(X,S1) and
 m(X,S2)))
and (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)))))) and (a([S3],(
 (\+
e([X], m(X,S1) and m(X,S3))) and (e([Y], m(Y,S1) and (a([Z], (m(Z,S3) ->
leq(Z,Y)))))) -> (a([X], ( m(X,S3) -> m(X,S2))))))))))) and
 (a([S1],(e([X], m(X,S1)) -> e([S2],(\+ e([X], m(X,S1) and m(X,S2)))
and (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)))))) and (a([S3],(
 (\+
e([X], m(X,S1) and m(X,S3))) and (e([Y], m(Y,S1) and (a([Z], (m(Z,S3) ->
leq(Z,Y)))))) -> (a([X], ( m(X,S3) -> m(X,S2))))))))))) or \+
 ((a([S1],(e([X], m(X,S1)) -> e([S2],(\+ e([X], m(X,S1) and m(X,S2)))
and (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)))))) and (a([S3],(
 (\+
e([X], m(X,S1) and m(X,S3))) and (e([Y], m(Y,S1) and (a([Z], (m(Z,S3) ->
leq(Z,Y)))))) -> (a([X], ( m(X,S3) -> m(X,S2))))))))))) and
 (a([S1],(e([X], m(X,S1)) -> e([S2],(\+ e([X], m(X,S1) and m(X,S2)))
and (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)))))) and (a([S3],(
 (\+
e([X], m(X,S1) and m(X,S3))) and (e([Y], m(Y,S1) and (a([Z], (m(Z,S3) ->
leq(Z,Y)))))) -> (a([X], ( m(X,S3) -> m(X,S2))))))))))))).
% 1. 4540ms
% 2. 3810ms no write
% 3. 2140ms indexing for unfolding and folding
% 4.  990ms avoiding common subformulas in LT
% 5.  980ms folding modulo reordering of literals
% 6.  880ms cut insertion
% 7.  650ms subsumption
% 8.  360ms deletion of useless clauses + better indexing on neg.unfold

% prop1 :- every finite, nonempty set S of nat has a maximum element M
prop1 :-
prove(a([S], (e([Y],m(Y,S))->e([M], m(M,S) and
a([X],(m(X,S)->leq(X,M))))))).
% 60ms
% 4. 10ms

% prop1 :- every finite, nonempty set S of nat has a maximum element M
propmax :-
prove(a([S], (e([Y],m(Y,S))->e([M], m(M,S) and
\+ e([X],(m(X,S) and gr(X,M))))))).


prop1neg :-
prove((\+ a([S], (e([Y],m(Y,S))->e([M], m(M,S) and
a([X],(m(X,S)->leq(X,M)))))))).
% 10ms

% prop2:- the empty set is a subset of every set
prop2 :-
prove(a([S1,S2], (emptyset(S1) -> a([X],(m(X,S1) -> m(X,S2)))))).
%0ms

prop2neg :-
prove((\+ a([S1,S2], (emptyset(S1) -> a([X],(m(X,S1) -> m(X,S2))))))).


/* prop3 :- for every finite nonempty set S1 there exists the largest
finite set S2 such that:  S1 /\ S2 = emptyset
and  max(S2) =< max(S1)*/
prop3 :-
prove((a([S1],(e([X], m(X,S1)) ->
	       e([S2],(\+ e([X], m(X,S1) and m(X,S2))) and
	               (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)))))) and
	               		(a([S3],(((\+ e([X], m(X,S1) and m(X,S3))) and
		         	          (e([Y], m(Y,S1) and (a([Z], (m(Z,S3) -> leq(Z,Y))))))) ->
					  (a([X], ( m(X,S3) -> m(X,S2)))))))))))).
% 1. 2480ms
% 3. 1080ms
% 4.  970ms
% 5.  960ms
% 6.  850ms
% 7.  630ms
% 8.  350ms

prop3neg :-
prove((\+ a([S1],(e([X], m(X,S1)) -> e([S2],(\+ e([X], m(X,S1) and
m(X,S2))) and (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)))))) and
(a([S3],( (\+ e([X], m(X,S1) and m(X,S3))) and (e([Y], m(Y,S1) and
(a([Z],
(m(Z,S3) -> leq(Z,Y)))))) -> (a([X], ( m(X,S3) -> m(X,S2)))))))))))).
% 1. 1800ms
% 3. 1070ms
% 4.  950ms
% 6.  210ms ?
% 7.  630ms
% 8.  360ms

% prop4:- two sets are equal iff they have the same elements
prop4 :-
prove(a([S1,S2], (eq_set(S1,S2) <-> a([X], (m(X,S1) <-> m(X,S2)))))).
% 1. 510ms
% 4. 160ms
% 6. 290ms
% 7. 170ms
% 8. 200ms

prop4neg :-
prove(\+ a([S1,S2], (eq_set(S1,S2) <-> a([X], (m(X,S1) <-> m(X,S2)))))).
% 1. 390ms
% 4. 170ms
% 5. 290ms
% 6. 290ms
% 7. 170ms
% 8. 200ms

% prop5 :- two natural numbers are equal iff they belong to the same sets
prop5 :-
prove(a([X,Y], (eq_nat(X,Y) <-> a([S], (m(X,S) <-> m(Y,S)))))).
% 1. 360ms
% 4. 120ms
% 5. 200ms
% 6. 200ms
% 7. 120ms
% 8. 150ms

prop5neg :-
prove(\+a([X,Y], (eq_nat(X,Y) <-> a([S], (m(X,S) <-> m(Y,S)))))).
% 4. 120ms
% 6. 200ms
% 7. 130ms
% 8. 150ms

%prop6 :- no set exists which is nonempty and upwards closed wrt
% successor
prop6 :-
prove(\+ e([S],(e([M],m(M,S)) and \+ e([N], (m(N,S) and
\+ m(s(N),S)))))).

%prop7 :- no set exists which contains 0 and is upwards closed wrt
%successor
prop7 :- prove(\+ e([S],(m(0,S) and \+ e([N], (m(N,S) and
\+ m(s(N),S)))))).


%%%%% SYNTHESIS EXAMPLES %%%%%%%%%%

% synth0 :- synthesis of program for
% computing the maximum element M of a non-empty set S
synth0 :-
synth(max(S,M),(m(M,S) and a([X],(m(X,S)->leq(X,M))))).
% 6. 50ms

% synth1 :- synthesis of program for
% computing the maximum element M of a set S
synth1 :-
synth(max(S,M),(e([Y],m(Y,S))->(m(M,S) and a([X],(m(X,S)->leq(X,M)))))).
% 6. 50ms

% other synthesis examples (suggested by Michael Leuschel)

synth2 :-
synth(newp(S),a([X],((\+ m(X,S)) -> e([Y], (m(Y,S) and leq(Y,X)) )) )).

synth3 :-
synth(newp(S),a([X],((\+ m(X,S)) -> e([Y], (m(Y,S) and (leq(Y,X) and (\+
eq_nat(X,Y))) ))) )).

synth4 :-
synth(newp(S),a([X], (m(s(X),S) -> (\+ m(X,S))))).

synth5 :-
synth(newp(S,S2),a([S1],( ((a([Y],(m(Y,S) -> m(Y,S1))))) -> a([X],((\+
m(X,S1)) -> e([Y], (m(Y,S2) and (leq(Y,X) and (\+ eq_nat(X,Y))) )))
 )))).
% 6. 200ms
% 8. 120ms

% subset relation

synth6 :-
synth(subset(R,S),a([X],(m(X,R) -> m(X,S)))).


% synthesis of pseudo_compl(S1,S2)  such that S1 and S2 are finite sets:
% S1 intersection S2 = emptyset
% and  max(S2) < max(S1)
% and S2 is the greatest such a finite set

synth7:-
synth(pseudo_compl(S1,S2),(((\+ e([X], (m(X,S1) and m(X,S2))))
and
(e([Y], (m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y))))))))
and
a([S3], ((\+ e([X], (m(X,S1) and m(X,S3))))
and
(e([Y], (m(Y,S1) and (a([Z], (m(Z,S3) -> leq(Z,Y)))))))
-> (a([X], (m(X,S3) -> m(X,S2)))))))).

%5. 810ms
%6. 690ms
%7. 640ms
%8. 380ms

synth8 :-
synth(min_not_in(S,N), ((\+ m(N,S)) and a([N1], 
((\+m(N1,S)) -> leq(N,N1))))).
%PIII   0ms

synth9 :-
synth(max_num(N), a([N1],leq(N1,N))).



