% WS2S defined in file Progs/ws2s

%every finite, nonempty set S of words in {s0,s1}* has a maximal element M
%(in the leq partial order)

prop1 :- prove(a([S],(e([Y],m(Y,S)) -> e([M], m(M,S) and a([X],((m(X,S) and
leq(M,X)) -> eq(M,X))))))).
%4. 170ms
%8.  70ms

prop1neg :-
prove(\+ a([S], (e([Y],m(Y,S))->e([M], m(M,S) and a([X],((m(X,S) and
leq(M,X)) -> eq(M,X))))))).
%4. 160ms
%8. 100ms

prop2 :-
prove(a([X,Y], (eq(X,Y) -> a([S],(m(X,S) -> m(Y,S)))))).
%8. 10ms

prop2neg :-
prove(\+ a([X,Y], (eq(X,Y) -> a([S],(m(X,S) -> m(Y,S)))))).
%8. 10ms

prop3 :-
prove(a([X,Y], (eq(X,Y) -> a([S],(m(X,S) <-> m(Y,S)))))).
%8. 390ms

prop3neg :-
prove(\+ a([X,Y], (eq(X,Y) -> a([S],(m(X,S) <-> m(Y,S)))))).
%8. 400ms

prop4 :-
prove(a([X,Y], (a([S],(m(X,S) <-> m(Y,S))) -> eq(X,Y)))
and a([X,Y], (eq(X,Y) -> a([S],(m(X,S) <-> m(Y,S)))))).
%8. 660ms

prop5 :-
prove(a([X,Y], (eq(X,Y) <-> a([S],(m(X,S) <-> m(Y,S)))))).
%8. oo

prop5neg :-
prove(\+ a([X,Y], (eq(X,Y) <-> a([S],(m(X,S) <-> m(Y,S)))))).
%9. oo


/* Synthesis of a program for computing the maximum of a (possibly empty)
set

(e([Y],m(Y,S)) -> m(M,S) and a([X],(m(X,S)->leq(X,M))))
and
(a([Y], \+ m(Y,S)) -> eq_nat(M,0)).

SUCCEDED
*/

/* for every finite nonempty set S1 there exists a finite set S2 such that:
 S1 /\ S2 = emptyset
 and  max(S2) < max(S1)
 and S2 is the greater such a finite set

a([S1],
 ( e([X], m(X,S1)) ->
  e([S2],
  (\+ e([X], m(X,S1) and m(X,S2)))

  and

  (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)) ))  ))

  and

  (a([S3],
  (
  (\+ e([X], m(X,S1) and m(X,S3)))

  and

  (e([Y], m(Y,S1) and (a([Z], (m(Z,S3) -> leq(Z,Y)) ))  ))

   -> (a([X], ( m(X,S3) -> m(X,S2))))  )
  ))
 ) )
).

*/

/* synthesis of new1(S1,S2)  such that S1 and S2 are finite sets:
 S1 /\ S2 = emptyset
 and  max(S2) < max(S1)
 and S2 is the greater such a finite set

  (\+ e([X], m(X,S1) and m(X,S2)))

  and

  (e([Y], m(Y,S1) and (a([Z], (m(Z,S2) -> leq(Z,Y)) ))  ))

  and

  (a([S3],
  (
  (\+ e([X], m(X,S1) and m(X,S3)))

  and

  (e([Y], m(Y,S1) and (a([Z], (m(Z,S3) -> leq(Z,Y)) ))  ))

   -> (a([X], ( m(X,S3) -> m(X,S2))))  )
  )).

*/

/* every finite set S of nat has a subset R which is the empty set
 a([S],e([R],
a([X],(m(X,R) -> m(X,S))) and a([Y],\+ m(Y,R))
  )).

*/



/* Synthesis of the empty set

a([S], a([X],(m(X,R) -> m(X,S))) and a([Y],\+ m(Y,R))).


*/


/*
subset

a([X],(m(X,R) -> m(X,S)))    % 0.390

a([
*/

/*   the empty set is a subset of every set

a([S1,S2], (emptyset(S1) -> a([X],(m(X,S1) -> m(X,S2))))).

*/


/*   two sets are equal iff they have the same elements

a([S1,S2],
(eq_set(S1,S2) -> a([X], (m(X,S1) -> m(X,S2)) and (m(X,S2) -> m(X,S1))))
and
(a([X], (m(X,S1) -> m(X,S2)) and (m(X,S2) -> m(X,S1))) -> eq_set(S1,S2))
).
*/

/*
a([X,Y],
(eq_nat(X,Y) -> a([S], (m(X,S) -> m(Y,S)) and (m(Y,S) -> m(X,S))))
and
(a([S], (m(X,S) -> m(Y,S)) and (m(Y,S) -> m(X,S))) -> eq_nat(X,Y))
).
*/