% Microwave Oven [Clarke et al. 2000, pp.38-39]

%% Transitions

t(1,2).
t(1,3).
t(2,5).
t(3,1).
t(3,6).
t(4,1).
t(4,3).
t(4,4).
t(5,2).
t(5,3).
t(6,7).
t(7,4).

ts(1,[2,3]).
ts(2,[5]).
ts(3,[1,6]).
ts(4,[1,3,4]).
ts(5,[2,3]).
ts(6,[7]).
ts(7,[4]).


% Elementary Properties

elem(S,true).
elem(2,start).
elem(2,error).
elem(3,close).
elem(4,close).
elem(4,heat).
elem(5,start).
elem(5,close).
elem(5,error).
elem(6,start).
elem(6,close).
elem(7,start).
elem(7,close).
elem(7,heat).


% Temporal Properties

p01 :- sat(1,eg(not(start))). %true
p02 :- sat(1,er(heat,not(error))). %true
p03 :- sat(1,au(not(heat),error)). %false
p1 :- sat(1,ag(imp(start,af(heat)))). %false

p4 :- sat(1,ef(and(not(close),and(start,and(ef(heat),eg(error)))))). %true
p5 :- sat(1,ef(and(close,and(start,and(ef(heat),eg(error)))))). %true
p6 :- sat(1,ag(or(not(start),error))). %false
p7 :- sat(1,ag(or(not(start),not(close)))). %false
p8 :- sat(1,not(eu(true,and(not(close),and(start,and(ef(heat),eg(error))))))). %false
p9 :- sat(1,not(eu(ef(and(not(close),and(start,and(start,and(ef(heat),eg(error)))))),
	and(not(close),and(start,or(ef(heat),eg(error))))))). % false
p10 :- sat(1,au(ef(and(not(close),and(start,and(ef(heat),eg(error))))),
	ag(or(not(start),error)))). %false
p11 :- sat(1,au(ef(and(not(close),and(start,and(ef(heat),eg(error))))),
	not(ef(and(not(close),and(start,and(ef(heat),eg(error)))))))). %false
p12 :- sat(1,eu(ag(imp(start,af(heat))),not(ef(ex(and(error,ag(imp(start,af(heat))))))))).
%true
p13 :- sat(1,eu(ag(imp(start,af(eu(ag(imp(start,af(heat))),
not(ef(ex(and(error,ag(imp(start,af(eu(ag(imp(start,af(heat))),
not(ef(ex(and(error,ag(imp(start,af(heat))))))))))))))))))),
not(ef(ex(and(error,ag(imp(start,af(eu(ag(imp(start,af(heat))),
not(ef(ex(and(error,ag(imp(start,af(heat))))))))))))))))).
%false 550ms

