%--- Definite Buy_example1 ---


holds_played2([play2|A]) :- holds_p1_np2(A).
holds_played2([buy|A]) :- holds_played2(A).
holds_played1([play1|A]) :- holds_b_np1(A).
holds_played1([play2|A]) :- holds_p1_np2(A).
holds_bought([buy|A]).
holds_bought([play1|A]) :- holds_b_np1(A).

holds_p1_np2([play1|A]) :- holds_b_np1(A).
holds_b_np1([buy|A]).



%TYPE DEFINITIONS

history([]).
history([buy|Xs]) :- history(Xs).
history([play1|Xs]) :- history(Xs).
history([play2|Xs]) :- history(Xs).


%TYPE DECLARATIONS

type(holds_bought,1,[history]).
type(holds_played1,1,[history]).
type(holds_played2,1,[history]).
type(holds_p1_np2,1,[history]).
type(holds_b_np1,1,[history]).


synth1 :-
synth(played2_and_not_bought(H),(holds_played2(H) and \+ holds_bought(H))).

/*
Synthesized Program: 
16. new1([play1|A]) :- new2(A).
17. new2([buy|A]).
18. played2_and_not_bought([play2|A]) :- new1(A).
*/

synth2 :-
synth(played1_and_not_bought(H),(holds_played1(H) and \+ holds_bought(H))).

/*
Synthesized Program: 
19. new3([play1|A]) :- new4(A).
20. new4([buy|A]).
21. played1_and_not_bought([play2|A]) :- new3(A).
*/

synth3 :-
synth(not_bought_and_played1(H),((\+ holds_bought(H)) and holds_played1(H))).

/*
Synthesized Program: 
16. new1([play1|A]) :- new2(A).
17. new2([buy|A]).
18. not_bought_and_played1([play2|A]) :- new1(A).
*/
