:- dynamic init_prog_max_coeff/1.

initialize_max_coeff(P) :-
	retractall(init_prog_max_coeff(_)),
	prog_max_coeff_sum(P,M),
	assert(init_prog_max_coeff(M)).
%	nl, write('max coeff sum'), write(M), nl.
	
prog_max_coeff_sum(P,M) :-
	findall(X,
	(member(C,P),
	 clause_bd_cns(C,Cns),
	 max_coeff_sums(Cns,0,X)),
	Xs),
	pos_list_max(Xs,M).

embedded_clause((_,B1),(_,B2)) :- embedded_cns_goal(B1,B2).

embedded_cns_goal(CGoal1,CGoal2) :-
	CGoal1 = bd(C1,Goal1),
	CGoal2 = bd(C2,Goal2),
	variant(Goal1,Goal2),
	less_cns_sum(C1,C2).

less_cns_sum(C1,C2) :-
	max_coeff_sums(C1,0,M1),
	max_coeff_sums(C2,0,M2),
	init_prog_max_coeff(Maxcoeff),
	{M1<M2,
	 Maxcoeff<M2}.

max_coeff_sums([],M,M).
max_coeff_sums([C|Cs],M,N) :-
	coeff_sum(C,SC),
	max_num(M,SC,M1),
	max_coeff_sums(Cs,M1,N).

coeff_sum(C,S) :- var(C), !, {S=0}.
coeff_sum(rat(X,Y),S) :-
	!,
	X1 is abs(X),
	Y1 is abs(Y),
	S=rat(X1,Y1).
coeff_sum(C,S) :-
	number(C), !,
	S1 is abs(C),
	S=rat(S1,1).
coeff_sum(C,S) :-
	C=..[_|Args],
	coeff_sum_list(Args,0,S).

coeff_sum_list([],S,S).
coeff_sum_list([C|Cs],A,S) :-
	coeff_sum(C,SC),
	{A1=SC+A},
	coeff_sum_list(Cs,A1,S).

max_num(X,Y,Z) :- {X>=Y} -> Z=X ; Z=Y.

pos_list_max(L,M) :- plm(L,0,M).

plm([],M,M).
plm([X|Xs],A,M) :-
	max_num(X,A,B),
	plm(Xs,B,M).