%%% WIDENING

:- use_module(hull_clpq).

clause_widening(D1,D2,D3) :-
	copy_term(D1,(_H1,bd(C1,B1))),
	copy_term(D2,(H2,bd(C2,B2))),
	term_variables(B1,V1),
	term_variables(B2,V2),
	convex_hull(V1,C1,V2,C2,V3,C3),
	V3=V2,
	keep_leq_cns(C3,C1,C4),
	D3=(H2,bd(C4,B2)).


%%% keep_leq_cns(C1,C2,C3)
%%% C3 is the subset of constraints in C1 which are leq than some constraint in C2

keep_leq_cns([],_C2,[]).
keep_leq_cns(C1,C2,E) :-
	C1=[PC1|PC1s],
	((member(PC2,C2), leq_cns(PC1,PC2)) ->
	    (E=[PC1|E1],
	    keep_leq_cns(PC1s,C2,E1))
	;
	    keep_leq_cns(PC1s,C2,E)
	).

leq_cns(C1,C2) :-
	max_coeff(C1,M1),
	max_coeff(C2,M2),
	init_prog_max_coeff(Maxcoeff),
	{M1=<max(M2,Maxcoeff)}.


convex_hull_cl(D1,D2,D3) :-
	copy_term(D1,(_H1,bd(C1,B1))),
	copy_term(D2,(H2,bd(C2,B2))),
	term_variables(B1,V1),
	term_variables(B2,V2),
	convex_hull(V1,C1,V2,C2,V3,C3),
	V3=V2,
	D3=(H2,bd(C3,B2)).

/*
test1(C) :-  keep_entailed([X>=2,X>=3,X=<2],[X=:=3],C).
test2(C) :-  keep_entailed([X>=2,X>=3,X=<2],[X=:=3,X=:=1],C).
test3(C) :-  keep_entailed([X>=2,X>=5,X=<8],[X=:=3],C).
*/

