%%% WIDENING

clause_widening(D1,D2,D3) :-
	copy_term(D1,(H1,bd(C1,B1))),
	copy_term(D2,(H2,bd(C2,B2))),
	term_variables(H1,V1),
	term_variables(H2,V2),
	V1=V2,
	B1=B2,
	primitives(C1,I1),
	primitives(C2,I2),
	cns_widening(I1,I2,C3),
	D3=(H2,bd(C3,B2)).

cns_widening(C1,C2,C3) :-
	keep_entailed(C1,C2,E3),
	term_variables(E3,V3),
	solve(E3,V3,C3).

%%% keep_entailed(C1,C2,C3)
%%% C3 is the subset of the constraints in C1 entailed by C2

keep_entailed([],_C2,[]).
keep_entailed(C1,C2,E) :-
	C1=[PC1|PC1s],
	(entails(C2,[PC1]) ->
	    E=[PC1|E1],
	    keep_entailed(PC1s,C2,E1)
	;
	    keep_entailed(PC1s,C2,E)
	).


leq_cns(C1,C2) :-
	max_coeff(C1,M1),
	max_coeff(C2,M2),
	init_prog_max_coeff(Maxcoeff),
	{M1=<max(M2,Maxcoeff)}.


/*
test1(C) :-  keep_entailed([X>=2,X>=3,X=<2],[X=:=3],C).
test2(C) :-  keep_entailed([X>=2,X>=3,X=<2],[X=:=3,X=:=1],C).
test3(C) :-  keep_entailed([X>=2,X>=5,X=<8],[X=:=3],C).
*/

